SystemOrganization addCategory: #'Shapes-Base'!

Object subclass: #ShapeEnsemble
	instanceVariableNames: 'shape data legend attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shapes-Base'!

!ShapeEnsemble commentStamp: 'jmb 6/12/2008 16:56' prior: 0!
ShapeEnsemble contains both the shape file (with extension SHP) and the dbf file (with extension DBF). Information from the dbf can be used to color the map. Define a legend and the attribute to be used in the legend. Note that the ColorLegend and XBase packages are required then....

Structure:
 shape		ShapeMap -- comment about the purpose of instVar1
 data		DBF -- comment about the purpose of instVar2
 legend		ColorLegend -- comment about the purpose of instVar2
 attribute	String -- comment about the purpose of instVar2


Useful expressions:

	shown on Display: 
	| shpE |
	shpE := ShapeEnsemble fromFile: 'c:\esri\esridata\CANADA\province.shp'.
	shpE legend: ( ColorLegend mappedFrom: 0 step: 1000000 n: 20 hue: (Color red hue)).
	shpE attribute: 'POP1991'.
	^shpE display 

	show in an ImageMorph:
	| shpE legend |
	shpE := ShapeEnsemble fromFile: 'c:\esri\esridata\CANADA\province.shp'.
	legend := ColorLegend mapValuesToRandom: (shpE valuesOfAttribute: 'CODE').
	shpE legend: legend.
	shpE attribute: 'CODE'.
	^shpE displayMorphic	!

!ShapeEnsemble class methodsFor: 'examples' stamp: 'jmb 6/12/2008 16:28'!
display1
	"self display1"
	| shpE |
	shpE := ShapeEnsemble fromFile: 'c:\esri\esridata\CANADA\province.shp'.
	shpE legend: ( ColorLegend mappedFrom: 0 step: 1000000 n: 20 hue: (Color red hue)).
	shpE attribute: 'POP1991'.
	^shpE displayMorphic! !

!ShapeEnsemble class methodsFor: 'examples' stamp: 'jmb 7/7/2008 16:45'!
display2
	"self display2"

	| shpE legend |
	shpE := ShapeEnsemble fromFile: 'c:\esri\esridata\CANADA\province.shp'.
	shpE attribute: 'CODE'.
	legend := ColorLegend mapValuesToRandom: shpE valuesOfCurrentAttribute.
	shpE legend: legend.
	^shpE displayMorphic! !

!ShapeEnsemble class methodsFor: 'examples' stamp: 'jmb 7/7/2008 16:44'!
display3
	"self display3"

	| shpE legend |
	shpE := ShapeEnsemble fromFile: 'c:\esri\esridata\CANADA\province.shp'.
	shpE attribute: 'CODE'.
	legend := ColorLegend mapValues: shpE valuesOfCurrentAttribute
				mixing: { (Color red). (Color blue) }.
	legend allColorsAlpha: 0.1.
	shpE legend: legend.
	^shpE displayMorphic! !

!ShapeEnsemble class methodsFor: 'examples' stamp: 'jmb 7/8/2009 15:09'!
display4
	"self display4"

	| shpE legend |
	shpE := ShapeEnsemble fromFile: 'j:\etarcview\3D\poultry3D.shp'.
	shpE attribute: 'DIERSRT'.
	legend := ColorLegend mapValuesToRandom: shpE valuesOfCurrentAttribute.
	shpE legend: legend.
	^shpE displayMorphic! !

!ShapeEnsemble class methodsFor: 'examples' stamp: 'jmb 7/8/2009 15:10'!
display5
	"self display5"

	| shpE legend |
	shpE := ShapeEnsemble 
				fromFile: 'j:\etarcview\bushcricket\withET_CLASS\SmallSteps_B-HOE.shp'.
	shpE attribute: 'HabitatTyp'.
	legend := ColorLegend mapValuesToRandom: shpE valuesOfCurrentAttribute.
	shpE legend: legend.
	"legend storeOnFile."
	^shpE displayMorphic! !

!ShapeEnsemble class methodsFor: 'examples' stamp: 'jmb 7/8/2009 15:16'!
display6
	"self display6"

	| shpE legend |
	shpE := ShapeEnsemble 
				fromFile: 'j:\etarcview\bushcricket\withET_CLASS\SmallSteps_B-HOE.shp'.
	shpE attribute: 'ET_CLASS'.
	legend := ColorLegend mapValuesToRandom: shpE valuesOfCurrentAttribute.
	shpE legend: legend.
"	legend storeOnFile."
	^shpE displayMorphic! !

!ShapeEnsemble class methodsFor: 'examples' stamp: 'jmb 7/7/2008 16:26'!
displayNoLegend
	"self displayNoLegend"
	| shpE |
	shpE := ShapeEnsemble fromFile: 'c:\esri\esridata\CANADA\province.shp'.
	shpE attribute: 'POP1991'.
	^shpE displayMorphic! !

!ShapeEnsemble class methodsFor: 'examples' stamp: 'jmb 7/8/2009 15:16'!
displayNoLegend2
	"self displayNoLegend2"

	| shpE |
	shpE := ShapeEnsemble fromFile: 'j:\etarcview\bushcricket\withET_CLASS\SmallSteps_B-HOE.shp'.
	shpE attribute: 'HabitatTyp'.
	^shpE displayMorphic! !

!ShapeEnsemble class methodsFor: 'instance creation' stamp: 'jmb 6/9/2008 16:32'!
fromFile: aString 
	"ShapeEnsemble fromFile: 'c:\esri\esridata\CANADA\province.shp' "

	^self new shape: (ShapeMap fromFile: aString)
		data: (DBF on: (aString copyFrom: 1 to: aString size - 3) , 'DBF')! !

!ShapeEnsemble methodsFor: 'converting' stamp: 'jmb 6/17/2008 08:56'!
asForm
	"answer a Form with the receiver drawn on it. The whole map is projected on the Form"

	| form |
	form := Form extent: shape preferredFormExtent depth: Display depth.
	form fillWhite.
	self setColorsFromLegend.
	shape drawOn: (BalloonCanvas on: form).
	^form! !

!ShapeEnsemble methodsFor: 'accessing' stamp: 'jmb 6/10/2008 11:50'!
attribute: aString
	"the attribute whose values are used by the legend"

	attribute := aString! !

!ShapeEnsemble methodsFor: 'accessing' stamp: 'jmb 7/7/2008 16:37'!
dataAtCurrentAttribute
	"answer an Array with all the values for field referred to by attribute"

	^data contentsAtField: attribute! !

!ShapeEnsemble methodsFor: 'accessing' stamp: 'jmb 6/10/2008 12:31'!
dataAtField: aString
	"answer an Array with all the values for field named aString"

	^data contentsAtField: aString! !

!ShapeEnsemble methodsFor: 'accessing' stamp: 'jmb 6/9/2008 16:32'!
dataFields
	"data fields in the DBF"

	^data fields! !

!ShapeEnsemble methodsFor: 'accessing' stamp: 'jmb 6/9/2008 16:40'!
dataRecords
	"answer all the records in the DBF file, extracted from the bytes-stream"

	^data contents! !

!ShapeEnsemble methodsFor: 'displaying' stamp: 'jmb 6/12/2008 16:52'!
display
	"show on the Display"

	^self asForm displayOn: Display! !

!ShapeEnsemble methodsFor: 'displaying' stamp: 'jmb 6/12/2008 16:26'!
displayMorphic
	"open an ImageMorph with the receiver as an image"

	^(ImageMorph new image: self asForm) openInWorld! !

!ShapeEnsemble methodsFor: 'displaying' stamp: 'jmb 6/10/2008 11:54'!
drawOn: aCanvas
	
	self setColorsFromLegend.
	shape drawOn: aCanvas! !

!ShapeEnsemble methodsFor: 'accessing - legend' stamp: 'jmb 7/9/2009 15:11'!
legend: aLegend
	"use a predefined legend"
	legend := aLegend! !

!ShapeEnsemble methodsFor: 'displaying' stamp: 'jmb 7/7/2008 16:24'!
reasonableColorLegend
	^(Smalltalk at: #ColorLegend ifAbsent: [^nil]) 
		reasonableLegendForValues: (self dataAtField: attribute)! !

!ShapeEnsemble methodsFor: 'displaying' stamp: 'jmb 7/7/2008 16:29'!
reasonableColorLegendFor: aCollection
	^(Smalltalk at: #ColorLegend ifAbsent: [^nil]) 
		reasonableLegendForValues: aCollection! !

!ShapeEnsemble methodsFor: 'accessing - legend' stamp: 'jmb 7/9/2009 15:09'!
setColorMixLegendForAttribute: aString 
	attribute := aString.
	legend := ColorLegend mapValues: self valuesOfCurrentAttribute
				mixing: { (Color red). (Color blue) }! !

!ShapeEnsemble methodsFor: 'displaying' stamp: 'jmb 7/7/2008 16:39'!
setColorsFromLegend
	"fill the color array of the shape with colors determined by the Legend (and the selected attribute)"

	"if there is no ColorLegend defined, ask the ColorLegend for one"

	| values |
	legend isNil 
		ifTrue: 
			[values := self dataAtField: attribute.
			legend := self reasonableColorLegendFor: values.
			legend isNil ifTrue: [^self]].
	values isNil ifTrue: [values := self dataAtField: attribute].	"avoid going twice over the data values"
	shape colors: (legend colorForAll: values)! !

!ShapeEnsemble methodsFor: 'accessing - legend' stamp: 'jmb 7/9/2009 15:09'!
setRandomColorLegendForAttribute: aString 
	attribute := aString.
	legend := ColorLegend mapValuesToRandom: self valuesOfCurrentAttribute! !

!ShapeEnsemble methodsFor: 'accessing' stamp: 'jmb 6/17/2008 12:27'!
shape
	"answer the ShapeMap wrapped in the receiver"

	^shape! !

!ShapeEnsemble methodsFor: 'accessing' stamp: 'jmb 6/9/2008 16:39'!
shapeRecords
	"answer all the shapes in the shape file (extracted from the bytes)"

	^shape shapes! !

!ShapeEnsemble methodsFor: 'accessing' stamp: 'jmb 6/9/2008 16:12'!
shape: aShapeMap data: aDBF

	shape := aShapeMap.
	data := aDBF! !

!ShapeEnsemble methodsFor: 'accessing' stamp: 'jmb 6/10/2008 12:33'!
valuesOfAttribute: aString
	"answer an array with the unique values of attribute aString"

	^(self dataAtField: aString) asSet asSortedCollection asArray! !

!ShapeEnsemble methodsFor: 'accessing' stamp: 'jmb 7/7/2008 16:36'!
valuesOfCurrentAttribute
	"answer an array with the unique values of attribute aString"

	attribute isNil ifTrue: [^#()].
	^(self dataAtField: attribute) asSet asSortedCollection asArray! !

Object subclass: #ShapeMap
	instanceVariableNames: 'shpBytes shxBytes label colors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shapes-Base'!

!ShapeMap commentStamp: 'jmb 6/12/2008 16:35' prior: 0!
ShapeMap is the abstract superclass of classes representing different types of Shapes (maps in ESRI Shape format)
	
	Example: (ShapeMap fromFile: 'c:\esri\esridata\europe\country.shp' )
	or just extract all shapes from the file: (ShapeMap shapesFromFile: 'c:\esri\esridata\europe\country.shp' )

	For further displaying, the shapes can be rendered on a Form, using the asForm method.

	To display a ShapeMap with colors defined by attribute values of the DBF, wrap it in a ShapeEnsemble. 
	You will need the ColorLegend and XBase package in your image!!


The format is well-documented (google for ESRI shapefile format); relevant sections are reproduced in the comments. Usually also a .dbf file (XBase, dBase format) belongs to the actual 'shape'; a reader/writer for this format is available on SqueakMap. The records in the dbf (should) correspond to the shapes in the ShapeMap.

Currently handled shapefile formats: Point, PolyLine, Polygon, MultiPoint, PointZ, PolyLineZ, PolygonZ, MultiPointZ.
Not yet handled are: Null Shape, PointM, PolyLineM, PolygonM, MultiPointM, MultiPatch.
Should work on both little-endian and big-endian platforms.

Instance Variables:
	label	<String>	name of the shape file (without extension, without file path)
	shpBytes	<ByteArray>	the bytes in the .shp file (main file)
	shxBytes	<ByteArray>	the bytes in the .shx file (index file)

Accessing the Bytes is completely handled by the ShapeMap. The ShapeMap knows how to extract header info and shape or shape-index info, from the shpBytes and shxBytes. 
Header (100 Bytes, structure identical for shp|Bytes and shxBytes):
Position 	Field 			Value 		Type 	Order
Byte 0 		File Code 		9994 		Integer 	Big
Byte 4 		Unused 		0 			Integer 	Big
Byte 8 		Unused 		0 			Integer 	Big
Byte 12 	Unused 		0 			Integer 	Big
Byte 16 	Unused 		0 			Integer 	Big
Byte 20 	Unused 		0 			Integer 	Big
Byte 24 	File Length 		File Length 	Integer 	Big
Byte 28 	Version 		1000 		Integer 	Little
Byte 32 	Shape Type 	Shape Type Integer 	Little
Byte 36 	Bounding Box 	Xmin 		Double 	Little
Byte 44 	Bounding Box 	Ymin 		Double 	Little
Byte 52 	Bounding Box 	Xmax 		Double 	Little
Byte 60 	Bounding Box 	Ymax 		Double 	Little
Byte 68* 	Bounding Box 	Zmin 		Double 	Little
Byte 76* 	Bounding Box 	Zmax 		Double 	Little
Byte 84* 	Bounding Box 	Mmin 		Double 	Little
Byte 92* 	Bounding Box 	Mmax 		Double 	Little
* Unused, with value 0.0, if not Measured or Z type

The value for file length is the total length of the file in 16-bit words (including the fifty 16-bit words that make up the header). All the non-Null shapes in a shapefile are required to be of the same shape type. The values for shape type are as follows:
Value 	Shape Type
0 		Null Shape
1 		Point
3 		PolyLine
5 		Polygon
8 		MultiPoint
11 		PointZ
13 		PolyLineZ
15 		PolygonZ
18 		MultiPointZ
21 		PointM
23 		PolyLineM
25 		PolygonM
28 		MultiPointM
31 		MultiPatch

The Bounding Box in the main file header stores the actual extent of the shapes in the file: the minimum bounding rectangle orthogonal to the X and Y (and potentially the M and Z) axes that contains all shapes. If the shapefile is empty (that is, has no records), the values for Xmin, Ymin, Xmax, and Ymax are unspecified. Mmin and Mmax can contain "no data" values (see Numeric Types on page 2) for shapefiles of measured shape types that contain no measures.

Record Headers
The header for each record stores the record number and content length for the record. Record headers have a fixed length of 8 bytes. Table 2 shows the fields in the file header with their byte position, value, type, and byte order. In the table, position is with respect to the start of the record.

Position 	Field 				Value 			Type 	ByteOrder
Byte 0 		Record Number 		Record Number 	Integer 	Big
Byte 4 		Content Length 		Content Length 	Integer 	Big

Record numbers begin at 1.
The content length for a record is the length of the record contents section measured in 16-bit words. Each record, therefore, contributes (4 + content length) 16-bit words toward the total length of the file, as stored at Byte 24 in the file header.

Record Contents
Shapefile record contents consist of a shape type followed by the geometric data for the shape. The length of the record contents depends on the number of parts and vertices in a shape. For each shape type, we first describe the shape and then its mapping to record contents on disk. In the Tables (see subclasses), position is with respect to the start of the record contents.

Index file
The index file (.shx) contains a 100-byte header followed by 8-byte, fixed-length records. 
Position 	Field 			Value 			Type 	ByteOrder
Byte 0 		Offset 			Offset 			Integer 	Big
Byte 4 		Content Length 	Content Length 	Integer 	Big

The offset of a record in the main file is the number of 16-bit words from the start of the main file to the first byte of the record header for the record. Thus, the offset for the first record in the main file is 50, given the 100-byte header. The content length stored in the index record is the same as the value stored in the main file record header.!

ShapeMap subclass: #MultiPointShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shapes-Base'!

!MultiPointShape commentStamp: 'jmb 4/18/2004 21:57' prior: 0!
MultiPointShape represents a MultiPoint Type shape file - jmb, 13/4/2004

Record structure:
Position 	Field 			Value 		Type 		Number 	ByteOrder
Byte 0 		Shape Type 	8 			Integer 		1 			Little
Byte 4 		Box 			Box 		Double 		4 			Little
Byte 36 	NumPoints 		NumPoints 	Integer 		1 			Little
Byte 40 	Points 			Points 		Point 		NumPoints 	Little

!

!MultiPointShape class methodsFor: 'instance creation' stamp: 'jmb 7/8/2009 14:49'!
fromPointsColl: pointsColl boundingBox: aRectangle
	"create a complete PointShape using only points & boundingBox info"
	"send copyToFile to the instance, to move the bytes to files (*.shx, *.shp and *.dbf)"

	"(MultiPointShape fromPointsColl: 
		((1 to: 100) collect: [:i | Array with: (i * 10) @ (i * 10) with: (i * 10) @ (i * 10) + (100@0) ]) 
					boundingBox: 
		(Rectangle origin: 1@1 corner: 1000@1000)) copyToFile"

	"(MultiPointShape fromPointsColl: 
		((1 to: 100) collect: [:i | Array with: (i * 10) @ (i * 10) with: (i * 10) @ (i * 10) + (100@0) ]) 
					boundingBox: 
		(Rectangle origin: 1@1 corner: 1000@1000)) drawForm"	"??"


	^self new fromPointsColl: pointsColl boundingBox: aRectangle! !

!MultiPointShape class methodsFor: 'accessing' stamp: 'jmb 7/4/2008 17:05'!
shapeType
	^8
"
0	Null Shape
1	Point
3	PolyLine
5	Polygon
8	MultiPoint
11	PointZ
13	PolyLineZ
15	PolygonZ
18	MultiPointZ
21	PointM
23	PolyLineM
25	PolygonM
28	MultiPointM
31	MultiPatch
"! !

!MultiPointShape methodsFor: 'converting' stamp: 'jmb 6/17/2008 08:50'!
asFormExtent: aPoint depth: anInteger geoBoundingBox: aRect scaling: aNumber
	"answer the receiver displayed on a Form, within geographical bounds set by aRect and scaling determined by aNumber"

	| form canvas geoBB scaling m pointColor rect multiplier xMin yMax |
	form := Form extent: aPoint depth: anInteger.
	pointColor := self pointColor.
	form fillColor: self backgroundColor.
	canvas := BalloonCanvas on: form.
	canvas aaLevel: 0.
	"points stand out better without anti-aliasing"
	geoBB := aRect.
	xMin := geoBB origin x.
	yMax := geoBB corner y.
	scaling := aNumber.
	scaling > 1.0
		ifTrue: [multiplier := 1000.0.
			m := MatrixTransform2x3 withScale: 1 @ -1 * scaling / multiplier.
			m offset: xMin negated @ yMax * scaling.
			canvas transformBy: m.
			rect := (Rectangle origin: -1.0 @ -1.0 corner: 1.0 @ 1.0)
						scaleBy: (10 raisedToInteger: (1.0 / (scaling / multiplier) max: 1.0) log truncated).
			1
				to: self numberOfShapes
				do: [:i | 
					| points | 
					points := self multiPointsFromShapeIndex: i.
					points
						do: [:point | canvas
								drawRectangle: (rect translateBy: point * multiplier)
								color: pointColor
								borderWidth: 0
								borderColor: nil]]]
		ifFalse: [m := MatrixTransform2x3 withScale: 1 @ -1 * scaling.
			m offset: xMin negated @ yMax * scaling.
			canvas transformBy: m.
			rect := (Rectangle origin: -1.0 @ -1.0 corner: 1.0 @ 1.0)
						scaleBy: (10 raisedToInteger: (1.0 / scaling max: 1.0) log truncated).
			1
				to: self numberOfShapes
				do: [:i | 
					| points | 
					points := self multiPointsFromShapeIndex: i.
					points
						do: [:point | canvas
								drawRectangle: (rect translateBy: point)
								color: pointColor
								borderWidth: 0
								borderColor: nil]]].
	^ form! !

!MultiPointShape methodsFor: 'accessing - records' stamp: 'jmb 12/3/2004 13:02'!
boundingBoxForShapeAtOffset: anInteger 
	^Rectangle origin: ("shpBytes doubleAt:" self shpDoubleAt: anInteger + 12 bigEndian: false) 
				@ ("shpBytes doubleAt:" self shpDoubleAt: anInteger + 20 bigEndian: false)
		corner: ("shpBytes doubleAt:" self shpDoubleAt: anInteger + 28 bigEndian: false) 
				@ ("shpBytes doubleAt:" self shpDoubleAt: anInteger + 36 bigEndian: false)! !

!MultiPointShape methodsFor: 'editing' stamp: 'jmb 7/7/2009 22:17'!
fromPointsColl: vertsColl boundingBox: aRectangle
	"create a complete MultiPointShape using only points & boundingBox info"

"Record structure:
Position 	Field 			Value 		Type 		Number 	ByteOrder
Byte 0 		Shape Type 		8 			Integer 		1 			Little
Byte 4 		Box 			Box 		Double 		4 			Little
Byte 36 		NumPoints 		NumPoints 	Integer 		1 			Little
Byte 40 		Points 			Points 		Point 		NumPoints 	Little"

	"(MultiPointShape fromPointsColl: ((1 to: 100) collect: [:i | Array with: (i * 10) @ (i * 10) with: (i * 10) @ (i * 10) + (100@0) ]) boundingBox: (Rectangle origin: 1@1 corner: 1000@1000)) copyToFile"


	| n numPoints pointByteL basicRecHeaderByteL basicRecByteL totByteL fileByteL indexByteL stream recordContentByteL readStream offsetByte shType ros |
	n := vertsColl size.
	numPoints := vertsColl asArray collect: [:each | each size].	"number of points per shape"
	pointByteL := numPoints collect: [:each | each * 16].			"each point = 2 * 8 Bytes"
	basicRecHeaderByteL := 8.									"header: 4 + 4"
	basicRecByteL := 40.											"subheader: 4 (shptype) + (4 * 8 bb) + 4 (numpoints) "
	recordContentByteL := Array new: n.
	1 to: n
		do: 
			[:i | 
			recordContentByteL at: i
				put: basicRecByteL + (pointByteL at: i)].	"record content in bytes"
	totByteL := recordContentByteL sum + (basicRecHeaderByteL * n).	"and with the fixed record header bytes added"
	fileByteL := 100 + totByteL.
	shpBytes := ByteArray new: fileByteL.
	indexByteL := 100 + (n * 8).									"same header, with 8 bytes per record/shape"
	shxBytes := ByteArray new: indexByteL.

		"fill the header"
	self fileCode: 9994.
	self fileLength: fileByteL / 2.			"in Words, not Bytes"
	self version: 1000.						"always 1000"
	shType := self class shapeType.			"ask the class"
	self shapeType: shType.					"the MultiPoint type = 8"
	self xMin: aRectangle origin x asFloat.
	self xMax: aRectangle corner x asFloat.
	self yMin: aRectangle origin y asFloat.
	self yMax: aRectangle corner y asFloat.

		"copy the header to shxBytes"
	1 to: 100 do: [:i | shxBytes at: i put: (shpBytes at: i)].
		"but adjust file length!!"
	shxBytes longAt: 25 put: indexByteL / 2 bigEndian: true.	

	ros := OrderedCollection new: n.		"store for each record the index of its offset byte"
	offsetByte := 101.
	ros addFirst: offsetByte.
	1 to: n-1 do: [:i | offsetByte := offsetByte + 8 + (recordContentByteL at: i). ros addLast: offsetByte].
	ros := ros asArray.

		"fill the records"
	stream := WriteStream on: shpBytes.
	readStream := ReadStream on: (shpBytes copyFrom: 1 to: 100).
	100 timesRepeat: [stream nextPut: readStream next].
	1 to: n
		do: 
			[:index | 
			"write record header"

			| xMin xMax yMin yMax nPo start |
			self on: stream putNextULong: index bigEndian: true.					"4 Bytes (Record Number)"
			self on: stream putNextULong: (recordContentByteL at: index) / 2
				bigEndian: true.													"4 Bytes (Record Contents in 16bits words)"

			"write record contents"
			self on: stream putNextULong: shType bigEndian: false.				"4 Bytes (ShapeType)"
			"calculate and write boundingBox"
			start := (vertsColl at: index) first.
			xMin := xMax := start x.
			yMin := yMax := start y.
			(vertsColl at: index) do: 
					[:each | 
					xMin := xMin min: each x.
					xMax := xMax max: each x.
					yMin := yMin min: each y.
					yMax := yMax max: each y].
			self on: stream putNextDouble: xMin asFloat bigEndian: false.		"8 Bytes"
			self on: stream putNextDouble: yMin asFloat bigEndian: false.		"8 Bytes"
			self on: stream putNextDouble: xMax asFloat bigEndian: false.		"8 Bytes"
			self on: stream putNextDouble: yMax asFloat bigEndian: false.	"8 Bytes"

			nPo := numPoints at: index.
			self on: stream putNextULong: nPo bigEndian: false.		"4 Bytes (tot number of points)"

			(vertsColl at: index) do: 
					[:vert | 
					self on: stream putNextDouble: vert x asFloat bigEndian: false.
					self on: stream putNextDouble: vert y asFloat bigEndian: false]].
	shpBytes := stream contents.

	"fill the index bytes"
	stream := WriteStream on: shxBytes.
	readStream := ReadStream on: (shxBytes copyFrom: 1 to: 100).
	100 timesRepeat: [stream nextPut: readStream next].

	1 to: n
		do: 
			[:i | | offB | offB := ros at: i. 
			self on: stream putNextULong: ((offB - 1) / 2) bigEndian: true.
			self on: stream putNextULong: ((recordContentByteL at: i) / 2) bigEndian: true].
	shxBytes := stream contents
! !

!MultiPointShape methodsFor: 'accessing' stamp: 'jmb 3/22/2005 13:49'!
generalType

	^'Point'! !

!MultiPointShape methodsFor: 'testing' stamp: 'jmb 3/8/2005 09:57'!
hasMultiPoints
	^true! !

!MultiPointShape methodsFor: 'testing' stamp: 'jmb 3/1/2005 11:07'!
hasPoints
	^true! !

!MultiPointShape methodsFor: 'accessing - records' stamp: 'jmb 7/7/2009 21:51'!
multiPointsFromShapeAtOffset: anInteger 
	"answer a collection with the points in the shape whose record starts at Byte anInteger"

	"skip 8 Bytes for the Record Header + 4 for the Shape Type (8) + 32 Bytes for the Bounding Box = 44"

	| nPoints points offset |
	nPoints := shpBytes longAt: anInteger + 44 bigEndian: false.	"4 Bytes for the NumPoints"
	"points start at 44 + 4 = 48"
	points := OrderedCollection new: nPoints.
	offset := anInteger + 48.
	1 to: nPoints
		do: 
			[:i | 
			points addLast: ("shpBytes doubleAt:" self shpDoubleAt: offset + ((i - 1) * 16) bigEndian: false) 
						@ ("shpBytes doubleAt:" self shpDoubleAt: offset + 8 + ((i - 1) * 16) bigEndian: false)].
	^points asArray! !

!MultiPointShape methodsFor: 'accessing - shape by index' stamp: 'jmb 4/18/2004 21:56'!
multiPointsFromShapeIndex: anInteger 
	"answer the collection of points represented by the shape index anInteger - jmb, 13/4/2004"

	^self 
		multiPointsFromShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

!MultiPointShape methodsFor: 'accessing - contents' stamp: 'jmb 11/25/2004 21:51'!
shapes
	"answer the receiver's data as anArray with Arrays with Points"
	| n shapes |
	n := self numberOfShapes.
	shapes := Array new: n.
	1
		to: n
		do: [:i | shapes
				at: i
				put: (self multiPointsFromShapeIndex: i)].
	^ shapes! !

MultiPointShape subclass: #MultiPointZShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shapes-Base'!

!MultiPointZShape commentStamp: 'jmb 11/25/2004 12:34' prior: 0!
MultiPointZShape represents a MultiPointZ Type shape file. Record contains separate arrays with Zvalues and (optional) measures

Record structure:
Position 	Field 			Value 		Type 		Number 	ByteOrder
Byte 0 		Shape Type 		18 			Integer 		1 			Little
Byte 4 		Box 			Box 		Double 		4 			Little
Byte 36 		NumPoints 		NumPoints 	Integer 		1 			Little
Byte 40 		Points 			Points 		Point 		NumPoints 	Little
Byte X 		Zmin 			Zmin 		Double 		1 			Little
Byte X+8 	Zmax 			Zmax 		Double 		1 			Little
Byte X+16 	Zarray 			Zarray 		Double 		NumPoints 	Little
Byte Y* 	Mmin 			Mmin 		Double 		1 			Little
Byte Y+8* 	Mmax 			Mmax 		Double 		1 			Little
Byte Y+16* 	Marray 		Marray 	Double 		NumPoints 	Little
Note: X = 40 + (16 * NumPoints); Y = X + 16 + (8 * NumPoints)
* optional									

!

!MultiPointZShape class methodsFor: 'instance creation' stamp: 'jmb 7/8/2009 14:51'!
fromPointsColl: pointsColl boundingBox: aRectangle

	^self error: 'not yet implemented'! !

!MultiPointZShape class methodsFor: 'accessing' stamp: 'jmb 7/4/2008 17:05'!
shapeType
	^18
"
0	Null Shape
1	Point
3	PolyLine
5	Polygon
8	MultiPoint
11	PointZ
13	PolyLineZ
15	PolygonZ
18	MultiPointZ
21	PointM
23	PolyLineM
25	PolygonM
28	MultiPointM
31	MultiPatch
"! !

!MultiPointZShape methodsFor: 'accessing - records' stamp: 'jmb 12/3/2004 12:55'!
measuresFromShapeAtOffset: anInteger 
	"answer anArray with the measures (M values) for the shape whose record starts at Byte anInteger"
	"skip 8 Bytes for the Record Header + 4 for the Shape Type (18) + 32 Bytes 
	for the Bounding Box = 44"
	| nPoints ms mOffset |
	nPoints := self longAt: anInteger + 44 bigEndian: false.
	ms := Array new: nPoints.
	"anInteger + 8 -> skip header
	+ 40 + (16 * nPoints) -> X
	+ 16 + (8 * nPoints) -> Y
	+ 16 -> Marray"
"	mOffset := anInteger + 8 + 40 + (16 * nPoints) + 16 + (8 * nPoints) + 16."
	mOffset := anInteger + 80 + (24 * nPoints).	
	1
		to: nPoints
		do: [:i | ms at: i put: ("shpBytes doubleAt:" self shpDoubleAt: mOffset + ((i-1)*16) bigEndian: false)].
	^ ms! !

!MultiPointZShape methodsFor: 'accessing - records' stamp: 'jmb 12/3/2004 12:55'!
mMaxForShapeAtOffset: anInteger 
	"answer the mMax value of the shape whose record starts at Byte anInteger "
	"Note: X = 40 + (16 * NumPoints); Y = X + 16 + (8 * NumPoints)"
	| nPoints |
	nPoints := self longAt: anInteger + 44 bigEndian: false.
	"4 Bytes for the NumPoints"
	"points start at anInteger + 40 + 8 = anInteger + 48"
	^ "shpBytes doubleAt:" self shpDoubleAt: anInteger + 48 + (16 * nPoints) + 16 + (8 * nPoints) + 8 bigEndian: false

! !

!MultiPointZShape methodsFor: 'accessing - records' stamp: 'jmb 12/3/2004 12:55'!
mMinForShapeAtOffset: anInteger 
	"answer the mMin value of the shape whose record starts at Byte anInteger "
	"Note: X = 40 + (16 * NumPoints); Y = X + 16 + (8 * NumPoints)"
	| nPoints |
	nPoints := self longAt: anInteger + 44 bigEndian: false.
	"4 Bytes for the NumPoints"
	"points start at anInteger + 40 + 8 = anInteger + 48"
	^ "shpBytes doubleAt:" self shpDoubleAt: anInteger + 48 + (16 * nPoints) + 16 + (8 * nPoints) bigEndian: false

! !

!MultiPointZShape methodsFor: 'accessing - records' stamp: 'jmb 12/3/2004 12:54'!
multiPointsFromShapeAtOffset: anInteger 
	"answer a collection with the (B3DVector3) points in the shape whose 
	record starts at Byte anInteger"
	"points could be represented by B3DVector3. As I am not sure about 
	possible loss of precision, I avoided this. Replace the last Array 
	with:with:with: statement simply by ()@()@"

	| nPoints points offset zOffset |
	nPoints := self longAt: anInteger + 44 bigEndian: false.
	"4 Bytes for the NumPoints"
	"points start at 44 + 4 = 48"
	points := OrderedCollection new: nPoints.
	offset := anInteger + 48.
	zOffset := offset + (16 * nPoints) + 16.
	"skip also zMin and zMax bytes (8+8)"
	"z values start at zOffset"
	1
		to: nPoints
		do: [:i | points
				addLast: (Array
						with: ("shpBytes doubleAt:" self shpDoubleAt: offset + (i - 1 * 16) bigEndian: false)
						with: ("shpBytes doubleAt:" self shpDoubleAt: offset + 8 + (i - 1 * 16) bigEndian: false)
						with: ("shpBytes doubleAt:" self shpDoubleAt: zOffset + (i - 1 * 16) bigEndian: false))].
	^ points asArray! !

!MultiPointZShape methodsFor: 'accessing - contents' stamp: 'jmb 11/25/2004 22:03'!
shapes
	"answer the receiver's data as anArray with Arrays (shape) with Arrays (x y z)"
	| n shapes |
	n := self numberOfShapes.
	shapes := Array new: n.
	1
		to: n
		do: [:i | shapes
				at: i
				put: (self multiPointsFromShapeIndex: i)].
	^ shapes! !

!MultiPointZShape methodsFor: 'accessing - records' stamp: 'jmb 12/3/2004 12:56'!
zMaxForShapeAtOffset: anInteger 
	"answer the zMax value of the shape whose record starts at Byte anInteger "
	"skip 8 Bytes for the Record Header + 4 for the Shape Type (18) + 32 
	for the Bounding Box = 44"
	| nPoints |
	nPoints := self longAt: anInteger + 44 bigEndian: false.
	"4 Bytes for the NumPoints"
	"points start at 44 + 4 = 48"
	"skip also the zMin bytes (8)"
	^ "shpBytes doubleAt:" self shpDoubleAt: anInteger + 48 + (16 * nPoints) + 8 bigEndian: false! !

!MultiPointZShape methodsFor: 'accessing - records' stamp: 'jmb 12/3/2004 12:54'!
zMinForShapeAtOffset: anInteger 
	"answer the zMin value of the shape whose record starts at Byte anInteger "
	"skip 8 Bytes for the Record Header + 4 for the Shape Type (18) + 32 
	for the Bounding Box = 44"
	| nPoints |
	nPoints := self longAt: anInteger + 44 bigEndian: false.
	"4 Bytes for the NumPoints"
	"points start at 44 + 4 = 48"
	^ "shpBytes doubleAt:" self shpDoubleAt: anInteger + 48 + (16 * nPoints) bigEndian: false! !

!MultiPointZShape methodsFor: 'accessing - records' stamp: 'jmb 12/3/2004 12:56'!
zMinMaxForShapeAtOffset: anInteger 
	"answer a zMin@zMax point for the shape whose record starts at Byte 
	anInteger "
	"skip 8 Bytes for the Record Header + 4 for the Shape Type (18) + 32  
	for the Bounding Box = 44"
	| nPoints pos |
	nPoints := self longAt: anInteger + 44 bigEndian: false.
	"4 Bytes for the NumPoints"
	"points start at 44 + 4 = 48"
	pos := anInteger + 48 + (16 * nPoints).
	^ ("shpBytes doubleAt:" self shpDoubleAt: pos bigEndian: false)
		@ "shpBytes doubleAt:" self shpDoubleAt: pos + 8 bigEndian: false! !

ShapeMap subclass: #PointShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shapes-Base'!

!PointShape commentStamp: '<historical>' prior: 0!
PointShape represents a Point Type shape file.

Record structure (in Bytes):

[header: 8] [Data Type: 4] [X coordinate: 8] [Y coordinate: 8]

(documentation:)
Position 	Field 			Value 	Type 		Number 	ByteOrder
Byte 0 		Shape Type 		1 		Integer 		1 			Little
Byte 4 		X 				X 		Double 		1 			Little
Byte 12 		Y 				Y 		Double 		1 			Little
!

!PointShape class methodsFor: 'instance creation' stamp: 'jmb 7/7/2009 22:57'!
fromPointsColl: pointsColl boundingBox: aRectangle
	"create a complete PointShape using only points & boundingBox info"

	"(PointShape fromPointsColl: ((1 to: 100) collect: [:i | (i * 10) @ (i * 10)]) boundingBox: (Rectangle origin: 1@1 corner: 1000@1000)) copyToFile"
	"| rng | rng := Random new.
	(PointShape fromPointsColl: ((1 to: 100) collect: [:i | (rng next * 1000) @ (rng next * 1000)]) boundingBox: (Rectangle origin: 1@1 corner: 1000@1000)) copyToFile"
	"| rng | rng := Random new.
	(PointShape fromPointsColl: ((1 to: 100) collect: [:i | (rng next * 1000) @ (rng next * 1000)]) boundingBox: (Rectangle origin: 1@1 corner: 1000@1000)) drawForm"	"??"
	

	^self new fromPointsColl: pointsColl boundingBox: aRectangle! !

!PointShape class methodsFor: 'accessing' stamp: 'jmb 7/7/2009 15:58'!
shapeType
	^1
"
0	Null Shape
1	Point
3	PolyLine
5	Polygon
8	MultiPoint
11	PointZ
13	PolyLineZ
15	PolygonZ
18	MultiPointZ
21	PointM
23	PolyLineM
25	PolygonM
28	MultiPointM
31	MultiPatch
"! !

!PointShape methodsFor: 'editing' stamp: 'jmb 7/7/2009 23:14'!
fromPointsColl: vertsColl boundingBox: aRectangle
	"create a complete PointShape using only points & boundingBox info"


"Record structure (in Bytes):
[header: 8] [Data Type: 4] [X coordinate: 8] [Y coordinate: 8]
(documentation:)
Position 	Field 			Value 	Type 		Number 	ByteOrder
Byte 0 		Shape Type 		1 		Integer 		1 			Little
Byte 4 		X 				X 		Double 		1 			Little
Byte 12 		Y 				Y 		Double 		1 			Little"

	"(PointShape fromPointsColl: ((1 to: 100) collect: [:i | (i * 10) @ (i * 10)]) boundingBox: (Rectangle origin: 1@1 corner: 1000@1000)) copyToFile"


	| n basicRecHeaderByteL totByteL fileByteL indexByteL stream recordContentByteL readStream offsetByte shType ros |
	n := vertsColl size.
	basicRecHeaderByteL := 8.									"header: 4 + 4"
	recordContentByteL := Array new: n withAll: 20.				"record content in bytes (always 20: 4shptype + 8x + 8y)"
	totByteL := (20 * n) + (basicRecHeaderByteL * n).				"and with the fixed record header bytes added"
	fileByteL := 100 + totByteL.
	shpBytes := ByteArray new: fileByteL.
	indexByteL := 100 + (n * 8).									"same header, with 8 bytes per record/shape"
	shxBytes := ByteArray new: indexByteL.

		"fill the header"
	self fileCode: 9994.
	self fileLength: fileByteL / 2.			"in Words, not Bytes"
	self version: 1000.						"always 1000"
	shType := self class shapeType.			"ask the class"
	self shapeType: shType.					"the Point type = 1"
	self xMin: aRectangle origin x asFloat.
	self xMax: aRectangle corner x asFloat.
	self yMin: aRectangle origin y asFloat.
	self yMax: aRectangle corner y asFloat.

		"copy the header to shxBytes"
	1 to: 100 do: [:i | shxBytes at: i put: (shpBytes at: i)].
		"but adjust file length!!"
	shxBytes longAt: 25 put: indexByteL / 2 bigEndian: true.	

	ros := OrderedCollection new: n.		"store for each record the index of its offset byte"
	offsetByte := 101.
	ros addFirst: offsetByte.
	1 to: n-1 do: [:i | offsetByte := offsetByte + 8 + (recordContentByteL at: i) "=20". ros addLast: offsetByte].
	ros := ros asArray.

		"fill the records"
	stream := WriteStream on: shpBytes.
	readStream := ReadStream on: (shpBytes copyFrom: 1 to: 100).
	100 timesRepeat: [stream nextPut: readStream next].
	1 to: n
		do: 
			[:index | 
			"write record header"

			| point |
			self on: stream putNextULong: index bigEndian: true.					"4 Bytes (Record Number)"
			self on: stream putNextULong: (recordContentByteL at: index) / 2
				bigEndian: true.													"4 Bytes (Record Contents in 16bits words)"

			"write record contents"
			self on: stream putNextULong: shType bigEndian: false.				"4 Bytes (ShapeType)"

			"write the single point"
			point := vertsColl at: index. 
			self on: stream putNextDouble: point x asFloat bigEndian: false.
			self on: stream putNextDouble: point y asFloat bigEndian: false].
	shpBytes := stream contents.

	"fill the index bytes"
	stream := WriteStream on: shxBytes.
	readStream := ReadStream on: (shxBytes copyFrom: 1 to: 100).
	100 timesRepeat: [stream nextPut: readStream next].

	1 to: n
		do: 
			[:i | | offB | offB := ros at: i. 
			self on: stream putNextULong: ((offB - 1) / 2) bigEndian: true.
			self on: stream putNextULong: ((recordContentByteL at: i) / 2) bigEndian: true].
	shxBytes := stream contents! !

!PointShape methodsFor: 'accessing' stamp: 'jmb 3/22/2005 13:49'!
generalType

	^'Point'! !

!PointShape methodsFor: 'testing' stamp: 'jmb 3/1/2005 11:08'!
hasPoints
	^true! !

!PointShape methodsFor: 'accessing - shape by index' stamp: 'jmb 11/24/2004 10:56'!
point2DFromShapeIndex: anInteger 
	"answer the point represented by the shape index anInteger"
	"identical to basic #pointFromShapeIndex: anInteger"

	^self pointFromShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

!PointShape methodsFor: 'accessing - records' stamp: 'jmb 12/3/2004 12:57'!
pointFromShapeAtOffset: anInteger 
	"answer the point represented by the shape whose record starts at 
	anInteger "
	^ ("shpBytes doubleAt:" self shpDoubleAt: anInteger + 12 bigEndian: false)
		@ ("shpBytes doubleAt:" self shpDoubleAt: anInteger + 20 bigEndian: false)! !

!PointShape methodsFor: 'accessing - shape by index' stamp: 'jmb 11/24/2004 11:01'!
pointFromShapeIndex: anInteger 
	"answer the point represented by the shape index anInteger"

	^self pointFromShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

!PointShape methodsFor: 'accessing - contents' stamp: 'jmb 11/25/2004 22:20'!
shapes
	"answer the receiver's data as anArray with Points (or Array(x y z) for PointZShape)"
	| n shapes |
	n := self numberOfShapes.
	shapes := Array new: n.
	1
		to: n
		do: [:i | shapes
				at: i
				put: (self pointFromShapeIndex: i)].
	^ shapes! !

PointShape subclass: #PointZShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shapes-Base'!

!PointZShape commentStamp: '<historical>' prior: 0!
PointZShape represents a PointZ Type shape file. A PointZ consists of a triplet of double-precision coordinates in the order X, Y, Z plus a (optional) measure M.

Record structure (in Bytes):

[header: 8] [Data Type: 4] [X coordinate: 8] [Y coordinate: 8] [Z coordinate: 8] [Measure: 8]

(documentation:)
Position 	Field 			Value 	Type 		Number 	ByteOrder
Byte 0 		Shape Type 		11 		Integer 		1 			Little
Byte 4 		X 				X 		Double 		1 			Little
Byte 12 		Y 				Y 		Double 		1 			Little
Byte 20 		Z 				Y 		Double 		1 			Little
Byte 28 		M 				M 		Double 		1 			Little!

!PointZShape class methodsFor: 'instance creation' stamp: 'jmb 7/8/2009 14:52'!
fromPointsColl: pointsColl boundingBox: aRectangle

	^self error: 'not yet implemented'! !

!PointZShape class methodsFor: 'accessing' stamp: 'jmb 7/4/2008 17:06'!
shapeType
	^11
"
0	Null Shape
1	Point
3	PolyLine
5	Polygon
8	MultiPoint
11	PointZ
13	PolyLineZ
15	PolygonZ
18	MultiPointZ
21	PointM
23	PolyLineM
25	PolygonM
28	MultiPointM
31	MultiPatch
"! !

!PointZShape methodsFor: 'accessing - records' stamp: 'jmb 12/3/2004 12:59'!
measureForShapeAtOffset: anInteger 
	"answer the measure (M) value of the shape whose record starts at 
	anInteger "
	^ "shpBytes doubleAt:" self shpDoubleAt: anInteger + 36 bigEndian: false! !

!PointZShape methodsFor: 'accessing - shape by index' stamp: 'jmb 12/3/2004 13:14'!
point2DFromShapeIndex: anInteger 
	"answer the 2Dpoint represented by the shape index anInteger"
	^ super pointFromShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

!PointZShape methodsFor: 'accessing - records' stamp: 'jmb 12/3/2004 12:58'!
pointFromShapeAtOffset: anInteger 
	"answer the 3D point Array(x y z) represented by the shape whose  
	record starts at anInteger"
	"could return aB3DVector3 instead, by using ()@()@()"
	^ Array
		with: ("shpBytes doubleAt:" self shpDoubleAt: anInteger + 12 bigEndian: false)
		with: ("shpBytes doubleAt:" self shpDoubleAt: anInteger + 20 bigEndian: false)
		with: ("shpBytes doubleAt:" self shpDoubleAt: anInteger + 28 bigEndian: false)! !

ShapeMap subclass: #PolygonShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shapes-Base'!

!PolygonShape commentStamp: 'jmb 4/18/2004 21:46' prior: 0!
PolygonShape represents a Polygon Type shape file.

Excerpts from the documentation:

A polygon consists of one or more rings. A ring is a connected sequence of four or more points that form a closed, non-self-intersecting loop. A polygon may contain multiple outer rings. The order of vertices or orientation for a ring indicates which side of the ring is the interior of the polygon. The neighborhood to the right of an observer walking along the ring in vertex order is the neighborhood inside the polygon. Vertices of rings defining holes in polygons are in a counterclockwise direction. Vertices for a single, ringed polygon are, therefore, always in clockwise order. The rings of a polygon are referred to as its parts.

The following are important notes about Polygon shapes.
The rings are closed (the first and last vertex of a ring MUST be the same). The order of rings in the points array is not significant. Polygons stored in a shapefile must be clean. A clean polygon is one that
1. Has no self-intersections. This means that a segment belonging to one ring may not intersect a segment belonging to another ring. The rings of a polygon can touch each other at vertices but not along segments. Colinear segments are considered intersecting.
2. Has the inside of the polygon on the "correct" side of the line that defines it. The neighborhood to the right of an observer walking along the ring in vertex order is the inside of the polygon. Vertices for a single, ringed polygon are, therefore, always in clockwise order. Rings defining holes in these polygons have a counterclockwise orientation. "Dirty" polygons occur when the rings that define holes in the polygon also go clockwise, which causes overlapping interiors.


Position		Field			Value		Type	Number		ByteOrder
Byte 0 		Shape Type 	5 			Integer 	1 			Little
Byte 4 		Box 			Box 		Double 	4 			Little
Byte 36 	NumParts 		NumParts 	Integer 	1 			Little
Byte 40 	NumPoints 		NumPoints 	Integer 	1 			Little
Byte 44 	Parts 			Parts 		Integer 	NumParts 	Little
Byte X 		Points 			Points 		Point 	NumPoints 	Little
Note: X = 44 + 4 * NumParts

!

!PolygonShape class methodsFor: 'instance creation' stamp: 'jmb 7/7/2009 14:47'!
fromOutlineVertsColl: vertsColl boundingBox: aRectangle 
	"create a complete PolygonShape using only vertices & boundingBox info"

	"Only the outerboundary of each polygon is used"

	"(
	self fromOutlineVertsColl:  		
				{ 
				{1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 20 .
				{1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 50 .
				{1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 20 + (25@0) .
				{1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 20 + (50@0) .
				}
		boundingBox: (0@0 extent: 120@120)
	)
	drawForm
		"

	^self new fromOutlineVertsColl: vertsColl boundingBox: aRectangle! !

!PolygonShape class methodsFor: 'instance creation' stamp: 'jmb 7/7/2009 22:50'!
fromVertsColl: aColl boundingBox: aRectangle 
	"create a complete PolygonShape using outline + holes vertices & boundingBox info"

	"per polygon a collection with 1 or more point-collections, making up its outerboundary AND any holes"
	"ArcView expects the polygon to be CLOSED (last vertex = first vertex)"

	"(
	self fromVertsColl:  		
				{ 
				{ {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 20. } .
				{ {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 50.  {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} reversed * 25 + (35@35). } .
				{ {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 20 + (25@0). } .
				{ {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 20 + (50@0). } .
				}
		boundingBox: (0@0 extent: 120@120)
	)
	drawForm"

	"(
	self fromVertsColl:  		
				{ 
				{ {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 20. } .
				{ {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 50. } .
				{ {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 20 + (25@0). } .
				{ {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 20 + (50@0). } .
				}
		boundingBox: (0@0 extent: 120@120)
	)
	drawForm"

	"(PolygonShape fromVertsColl: (Array 
					with: (Array with: (Array with:1@100 with:  100@100  with: 100@1 with: 1@1 with:1@100  ) 
									with: (Array with:30@60 with:  60@60  with: 60@30 with: 30@30 with:30@60  ) reversed )
					with: (Array with: (Array with: 900@1000 with:  1000@1000  with: 1000@900 with: 900@900 with: 900@1000 ) ) )
					boundingBox: (Rectangle origin: 1@1 corner: 1000@1000) ) copyToFile "

	^self new fromVertsColl: aColl boundingBox: aRectangle! !

!PolygonShape class methodsFor: 'accessing' stamp: 'jmb 4/21/2005 21:54'!
polygonClass
	"answer the class representing the kind of polygons that my instances' shapes can be converted into" 

	^Smalltalk at: #SimplePolygon ifAbsent: [nil]! !

!PolygonShape class methodsFor: 'accessing' stamp: 'jmb 7/4/2008 17:02'!
shapeType
	^5! !

!PolygonShape methodsFor: 'converting' stamp: 'jmb 12/13/2006 09:30'!
asSimplePolygons
	"convert the contents of the Polygon Shape file into aCollection of SimplePolygons"
	"Expected functionality:
		#vertices: (setting the outer-vertices)
		#vertices
		#userID: (the record number in the shape is stored as userID)
		#hole (answering aCollection of other polygons representing the holes
		#absContainsPoint: (point-in-polygon test for outer boundary)"
	"when a single shape contains multiple (outer) rings, add only the first to the regular collection of SimplePolygons.
	This way, the index of the shape is preserved in the index of the SimplePolygon. Answer the collection of SimplePolygons,
	with any additional outer ring appended to the end of the collection (after index = numberOfShapes) " 

	"=> NB a thorough check of the spec is needed here: can we really have two outerboundaries for a single polygon-shape? "

	"(ShapeMap fromFile: 'd:\etarcview\giovanna\uso_corr.shp') asSimplePolygons"			
		
	"1 to: self numberOfShapes
		do: [:i | (self numPartsForShapeIndex: i) > 1 ifTrue: [result addLast: i]]. "

	| n polygons polygonClass additionalPolys |
	polygonClass := self class polygonClass.	
	polygonClass isNil ifTrue: [^nil].
	n := self numberOfShapes.
	polygons := OrderedCollection new: n + 100.
	additionalPolys := OrderedCollection new.
	1 to: self numberOfShapes
		do: 
			[:i | 
			| arcs newPolys bb |
			arcs := self verticesByPartsForShapeIndex: i.
			bb := self boundingBoxForShapeIndex: i.
			newPolys := arcs collect: [:each | polygonClass vertices: each].
			arcs size > 1 
				ifFalse: 
					[| newP |
					newP := newPolys first.
					newP userID: i.
					newP boundingBox: bb.
					polygons addLast: newP]
				ifTrue: 
					[| holes outers theOuter |
					holes := OrderedCollection new.
					outers := OrderedCollection new.
					newPolys do: 
							[:each | 
							each isPositive 
								ifTrue: [outers addLast: each]
								ifFalse: [holes addLast: each]].
					outers size > 1 
						ifTrue: 
							[holes isEmpty 
								ifFalse: 
									[holes do: 
											[:hole | 
											| testPoint index |
											testPoint := hole vertices first.
											index := outers findFirst: [:ring | ring absContainsPoint: testPoint].
											"assign the holes to the right outer ring" 
											index = 0 
												ifTrue: [self halt	"skip the hole --- dont know why this happens.."]
												ifFalse: 
													[theOuter := outers at: index.
													theOuter holes addLast: hole]]].
							outers do: [:each | each userID: i]. "dont set boundingBoxes here; things may not be what I think they are.." 
							polygons addLast: outers first.
							2 to: outers size do: [:index | additionalPolys addLast: (outers at: index)]]
						ifFalse: 
							[theOuter := outers first.	"only one outer-ring, so all holes should go into this ring"
							theOuter userID: i.
							theOuter boundingBox: bb.
							theOuter holes addAll: holes.
							polygons addLast: theOuter]]].
	additionalPolys isEmpty ifFalse: ["self halt. just to make you aware of this complication (that's not handled well)"].
	^polygons , additionalPolys! !

!PolygonShape methodsFor: 'converting' stamp: 'jmb 6/17/2008 08:53'!
asSimpleVectorLandscape
	"create polygon objects and answer a SimpleVectorLandscape with these polygons"
	"(ShapeMap fromFile: 'd:\etarcview\giovanna\uso_corr.shp') asSimpleVectorLandscape"			

	| landscape |
	landscape := (Smalltalk at: #SimpleVectorLandscape ifAbsent: [^nil]) polygons: self asSimplePolygons.
	landscape boundingBox: self boundingBox.
	^landscape! !

!PolygonShape methodsFor: 'accessing - records' stamp: 'jmb 12/3/2004 13:02'!
boundingBoxForShapeAtOffset: anInteger 
	^Rectangle origin: ("shpBytes doubleAt:" self shpDoubleAt: anInteger + 12 bigEndian: false) 
				@ ("shpBytes doubleAt:" self shpDoubleAt: anInteger + 20 bigEndian: false)
		corner: ("shpBytes doubleAt:" self shpDoubleAt: anInteger + 28 bigEndian: false) 
				@ ("shpBytes doubleAt:" self shpDoubleAt: anInteger + 36 bigEndian: false)! !

!PolygonShape methodsFor: 'accessing - shape by index' stamp: 'jmb 4/27/2004 13:08'!
boundingBoxForShapeIndex: anInteger 
	"extract the boundingBox for shape record anInteger"
	^ self
		boundingBoxForShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

!PolygonShape methodsFor: 'editing' stamp: 'jmb 7/7/2009 14:47'!
fromOutlineVertsColl: vertsColl boundingBox: aRectangle 
	"create a complete PolygonShape using only vertices & boundingBox info"

	"current limitation: only one collection of vertices per polygon/shape (so, only the outerboundary is handled)"

	"ShapeMorph new shapeMap: (ShapeMap fromFile: 'd:\squeak3\lgn4_clip_legenda2.shp')"

	"(PolygonShape fromOutlineVertsColl: (Array 
					with: (Array with:1@100 with:  100@100  with: 100@1 with: 1@1 with:1@100  )
					with: (Array with: 900@1000 with:  1000@1000  with: 1000@900 with: 900@900 with: 900@1000 ) )  
					boundingBox: (Rectangle origin: 1@1 corner: 1000@1000) ) copyToFile "

	| n numParts numPoints pointByteL basicRecHeaderByteL basicRecByteL totByteL fileByteL indexByteL stream recordContentByteL readStream offsetByte |
	n := vertsColl size.
	numParts := Array new: n withAll: 1.	"only 1 ring per shape"
	numPoints := vertsColl asArray collect: [:each | each size].	"number of vertices per shape"
	pointByteL := numPoints collect: [:each | each * 16].	"each point = 2 * 8 Bytes"
	basicRecHeaderByteL := 8.	"header: 4 + 4"
	basicRecByteL := 44.	" subheader: 4 + (4 * 8 bb) + 4 + 4 "
	recordContentByteL := Array new: n.
	1 to: n
		do: 
			[:i | 
			recordContentByteL at: i
				put: basicRecByteL + ((numParts at: i) * 4) + (pointByteL at: i)].	"record content in bytes"
	totByteL := recordContentByteL sum + (basicRecHeaderByteL * n).	"and with the fixed record header bytes added"
	fileByteL := 100 + totByteL.
	shpBytes := ByteArray new: fileByteL.
	indexByteL := 100 + (n * 8).	"same header, with 8 bytes per record/shape"
	shxBytes := ByteArray new: indexByteL.

	"fill the header"
	self fileCode: 9994.
	self fileLength: fileByteL / 2.	"in Words, not Bytes"
	self version: 1000.	"always 1000"
	self shapeType: self class shapeType.	"the Polygon type"
	self xMin: aRectangle origin x asFloat.
	self xMax: aRectangle corner x asFloat.
	self yMin: aRectangle origin y asFloat.
	self yMax: aRectangle corner y asFloat.

	"copy the header to shxBytes"
	1 to: 100 do: [:i | shxBytes at: i put: (shpBytes at: i)].
	shxBytes 
		longAt: 25
		put: indexByteL / 2
		bigEndian: true.	"but adjust file length!!"

	"fill the records"
	stream := WriteStream on: shpBytes.
	readStream := ReadStream on: (shpBytes copyFrom: 1 to: 100).
	100 timesRepeat: [stream nextPut: readStream next].
	1 to: n
		do: 
			[:index | 
			"write record header"

			| xMin xMax yMin yMax nPa nPo start |
			self 
				on: stream
				putNextULong: index
				bigEndian: true.	"4 Bytes (Record Number)"
			self 
				on: stream
				putNextULong: (recordContentByteL at: index) / 2
				bigEndian: true.	"4 Bytes (Record Contents in 16bits words)"

			"write record contents"
			self 
				on: stream
				putNextULong: self class shapeType
				bigEndian: false.	"4 Bytes (ShapeType)"
			"calculate and write boundingBox"
			start := (vertsColl at: index) first.
			xMin := xMax := start x.
			yMin := yMax := start y.
			(vertsColl at: index) do: 
					[:each | 
					xMin := xMin min: each x.
					xMax := xMax max: each x.
					yMin := yMin min: each y.
					yMax := yMax max: each y].
			self 
				on: stream
				putNextDouble: xMin asFloat
				bigEndian: false.	"8 Bytes"
			self 
				on: stream
				putNextDouble: yMin asFloat
				bigEndian: false.	"8 Bytes"
			self 
				on: stream
				putNextDouble: xMax asFloat
				bigEndian: false.	"8 Bytes"
			self 
				on: stream
				putNextDouble: yMax asFloat
				bigEndian: false.	"8 Bytes"
			nPa := numParts at: index.
			self 
				on: stream
				putNextULong: nPa
				bigEndian: false.	"4 Bytes (numParts)"
			nPo := numPoints at: index.
			self 
				on: stream
				putNextULong: nPo
				bigEndian: false.	"4 Bytes (tot number of points)"
			nPa timesRepeat: 
					[self 
						on: stream
						putNextULong: 0
						bigEndian: false].	"numParts * 4 Bytes"
			(vertsColl at: index) do: 
					[:vert | 
					self 
						on: stream
						putNextDouble: vert x asFloat
						bigEndian: false.
					self 
						on: stream
						putNextDouble: vert y asFloat
						bigEndian: false]].
	shpBytes := stream contents.

	"fill the index bytes"
	stream := WriteStream on: shxBytes.
	readStream := ReadStream on: (shxBytes copyFrom: 1 to: 100).
	100 timesRepeat: [stream nextPut: readStream next].
	offsetByte := 101.
	1 to: n
		do: 
			[:i | 
			self 
				on: stream
				putNextULong: (offsetByte - 1) / 2
				bigEndian: true.
			self 
				on: stream
				putNextULong: (recordContentByteL at: i) / 2
				bigEndian: true.
			offsetByte := offsetByte + 8 + (recordContentByteL at: i)].
	shxBytes := stream contents! !

!PolygonShape methodsFor: 'editing' stamp: 'jmb 7/7/2009 15:56'!
fromVertsColl: aColl boundingBox: aRectangle 
	"create a complete PolygonShape using outline + holes vertices & boundingBox info"

	"per polygon a collection with 1 or more point-collections, making up its outboundary and any holes"

	"(PolygonShape fromVertsColl: (Array 
					with: (Array with: (Array with:1@100 with:  100@100  with: 100@1 with: 1@1 with:1@100  ) 
									with: (Array with:30@60 with:  60@60  with: 60@30 with: 30@30 with:30@60  ) reversed )
					with: (Array with: (Array with: 900@1000 with:  1000@1000  with: 1000@900 with: 900@900 with: 900@1000 ) ) )
					boundingBox: (Rectangle origin: 1@1 corner: 1000@1000) ) copyToFile "

	| n numParts numPoints pointByteL basicRecHeaderByteL basicRecByteL totByteL fileByteL indexByteL stream recordContentByteL readStream offsetByte shType |
	n := aColl size.	"number of shapes"
	numParts := aColl asArray collect: [:each | each size].	"1 or more rings per shape"
	numPoints := aColl asArray 
				collect: [:rings | rings inject: 0 into: [:sum :each | sum + each size]].	"number of vertices per shape (in one or more rings)"
	pointByteL := numPoints collect: [:each | each * 16].	"each point = 2 * 8 Bytes"
	basicRecHeaderByteL := 8.	"header: 4 + 4"
	basicRecByteL := 44.	" subheader: 4 + (4 * 8 bb) + 4 + 4 "
	recordContentByteL := Array new: n.
	1 to: n
		do: 
			[:i | 
			recordContentByteL at: i
				put: basicRecByteL + ((numParts at: i) * 4) + (pointByteL at: i)].	"record content in bytes"
	totByteL := recordContentByteL sum + (basicRecHeaderByteL * n).	"and with the fixed record header bytes added"
	fileByteL := 100 + totByteL.
	shpBytes := ByteArray new: fileByteL.
	indexByteL := 100 + (n * 8).	"same header, with 8 bytes per record/shape"
	shxBytes := ByteArray new: indexByteL.

	"fill the header"
	self fileCode: 9994.
	self fileLength: fileByteL / 2.	"in Words, not Bytes"
	self version: 1000.				"always 1000"
	shType := self class shapeType.	"ask the class"
	self shapeType: shType.			"the Polygon type"
	self xMin: aRectangle origin x asFloat.
	self xMax: aRectangle corner x asFloat.
	self yMin: aRectangle origin y asFloat.
	self yMax: aRectangle corner y asFloat.

	"copy the header to shxBytes"
	1 to: 100 do: [:i | shxBytes at: i put: (shpBytes at: i)].
	shxBytes 
		longAt: 25
		put: indexByteL / 2
		bigEndian: true.	"but adjust file length!!"

	"fill the records"
	stream := WriteStream on: shpBytes.
	readStream := ReadStream on: (shpBytes copyFrom: 1 to: 100).
	100 timesRepeat: [stream nextPut: readStream next].
	1 to: n
		do: 
			[:index | 
			"write record header"

			| xMin xMax yMin yMax nPa nPo start rings |
			self 
				on: stream
				putNextULong: index
				bigEndian: true.	"4 Bytes (Record Number)"
			self 
				on: stream
				putNextULong: (recordContentByteL at: index) / 2
				bigEndian: true.	"4 Bytes (Record Contents in 16bits words)"

			"write record contents"
			self 
				on: stream
				putNextULong: shType
				bigEndian: false.	"4 Bytes (ShapeType)"
			"calculate and write boundingBox"
			rings := aColl at: index.	"collection of rings"
			start := rings first first.
			xMin := xMax := start x.
			yMin := yMax := start y.
			rings do: 
					[:ring | 
					ring do: 
							[:each | 
							xMin := xMin min: each x.
							xMax := xMax max: each x.
							yMin := yMin min: each y.
							yMax := yMax max: each y]].
			self 
				on: stream
				putNextDouble: xMin asFloat
				bigEndian: false.	"8 Bytes"
			self 
				on: stream
				putNextDouble: yMin asFloat
				bigEndian: false.	"8 Bytes"
			self 
				on: stream
				putNextDouble: xMax asFloat
				bigEndian: false.	"8 Bytes"
			self 
				on: stream
				putNextDouble: yMax asFloat
				bigEndian: false.	"8 Bytes"
			nPa := numParts at: index.
			self 
				on: stream
				putNextULong: nPa
				bigEndian: false.	"4 Bytes (numParts)"
			nPo := numPoints at: index.
			self 
				on: stream
				putNextULong: nPo
				bigEndian: false.	"4 Bytes (tot number of points)"
			nPa > 1 
				ifFalse: 
					[self 
						on: stream
						putNextULong: 0
						bigEndian: false	"numParts (=1) * 4 Bytes"]
				ifTrue: 
					[| ringOffsets ringSizes |
					ringSizes := (rings collect: [:each | each size]) asArray.	"ring sizes"
					2 to: nPa
						do: [:i | ringSizes at: i put: (ringSizes at: i - 1) + (ringSizes at: i)].	"cumulative"
					ringOffsets := #(0 ) , (ringSizes copyFrom: 1 to: ringSizes size - 1).	"translate into offsets"
					ringOffsets do: 
							[:each | 
							self 
								on: stream
								putNextULong: each
								bigEndian: false]].	"numParts * 4 Bytes"
			rings do: 
					[:ring | 
					ring do: 
							[:vert | 
							self 
								on: stream
								putNextDouble: vert x asFloat
								bigEndian: false.
							self 
								on: stream
								putNextDouble: vert y asFloat
								bigEndian: false]]].
	shpBytes := stream contents.

	"fill the index bytes"
	stream := WriteStream on: shxBytes.
	readStream := ReadStream on: (shxBytes copyFrom: 1 to: 100).
	100 timesRepeat: [stream nextPut: readStream next].
	offsetByte := 101.
	1 to: n
		do: 
			[:i | 
			self 
				on: stream
				putNextULong: (offsetByte - 1) / 2
				bigEndian: true.
			self 
				on: stream
				putNextULong: (recordContentByteL at: i) / 2
				bigEndian: true.
			offsetByte := offsetByte + 8 + (recordContentByteL at: i)].
	shxBytes := stream contents! !

!PolygonShape methodsFor: 'accessing' stamp: 'jmb 3/22/2005 13:49'!
generalType

	^'Polygon'! !

!PolygonShape methodsFor: 'testing' stamp: 'jmb 3/1/2005 11:08'!
hasPolygons
	^true! !

!PolygonShape methodsFor: 'selecting' stamp: 'jmb 4/18/2004 21:53'!
indicesShapesWithMultipleParts
	"answer a collection with the indices of shapes having more than one ring (part) - jmb, 5/4/2004"

	| result |
	result := OrderedCollection new: 100.
	1 to: self numberOfShapes
		do: [:i | (self numPartsForShapeIndex: i) > 1 ifTrue: [result addLast: i]].
	^result asArray! !

!PolygonShape methodsFor: 'accessing - records' stamp: 'jmb 4/27/2004 13:09'!
numPartsForShapeAtOffset: anInteger
	"anInteger is the byte number of the offset of the record holding polygon info"
	"numParts defines the number of rings in the polygon"

	^shpBytes longAt: anInteger + 8 + 36 bigEndian: false "add the 8-byte header + the 4-byte shapeType + (4 * 8-byte Box)"! !

!PolygonShape methodsFor: 'accessing - shape by index' stamp: 'jmb 4/27/2004 13:09'!
numPartsForShapeIndex: anInteger 
	"extract the number of parts for shape record anInteger"

	^self 
		numPartsForShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

!PolygonShape methodsFor: 'accessing - records' stamp: 'jmb 4/27/2004 13:10'!
numPointsForShapeAtOffset: anInteger
	"anInteger is the byte number of the offset of the record holding polygon info"
	"numPoints defines the TOTAL number of points (vertices) for all rings in the polygon"

	^shpBytes longAt: anInteger + 8 + 40 bigEndian: false "add the 8-byte header + the 4-byte shapeType + 4*8-byte Box + 4-byte numParts"! !

!PolygonShape methodsFor: 'accessing - shape by index' stamp: 'jmb 1/12/2006 15:45'!
numPointsForShapeIndex: anInteger 
	"extract the number of points for shape record anInteger"
	"numPoints defines the TOTAL number of points (vertices) for all rings in the polygon"

	^self 
		numPointsForShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

!PolygonShape methodsFor: 'accessing - records' stamp: 'jmb 4/27/2004 13:10'!
partsOffsetsForShapeAtOffset: anInteger 
	"anInteger is the byte number of the offset of the record holding polygon info"
	"parts(Offsets) defines the offsets for all rings in the polygon. Use this info to retrieve vertices per ring"

	| start n result |
	start := anInteger + 8 + 44.	"add the 8-byte header + the 4-byte shapeType + 4*8-byte Box + 4-byte numParts + 4-byte numPoints"
	n := self numPartsForShapeAtOffset: anInteger.
	result := Array new: n.
	1 to: n do: [:i | result at: i put: 1 + (shpBytes longAt: (i - 1) * 4 + start bigEndian: false)].
	^result! !

!PolygonShape methodsFor: 'accessing - shape by index' stamp: 'jmb 1/12/2006 16:28'!
partsOffsetsForShapeIndex: anInteger 
	"parts(Offsets) defines the offsets for all rings in the polygon. Use this info to retrieve vertices per ring"
	"NB offsets are relative to the start of the vertices (points) bytes. So the ring with offset 1 starts with the first x,y value"

	^ self partsOffsetsForShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

!PolygonShape methodsFor: 'accessing - contents' stamp: 'jmb 11/25/2004 22:24'!
shapes
	"answer the receiver's data as anArray with Arrays with Points"
	| n shapes |
	n := self numberOfShapes.
	shapes := Array new: n.
	1
		to: n
		do: [:i | shapes
				at: i
				put: (self verticesByPartsForShapeIndex: i)].
	^ shapes! !

!PolygonShape methodsFor: 'writing' stamp: 'jmb 1/12/2006 22:48'!
streamedShapesBytes
	"create the shape data bytes by streaming" 
	"shpBytes copyFrom: 101 to: shpBytes size"
	"(ShapeMap fromFile: 'd:\etarcview\giovanna\navelli_cocullo.shp') shapesBytes "
"
Position		Field			Value		Type	Number		ByteOrder
Byte 0 		Shape Type 	5 			Integer 	1 			Little
Byte 4 		Box 			Box 		Double 	4 			Little
Byte 36 	NumParts 		NumParts 	Integer 	1 			Little
Byte 40 	NumPoints 		NumPoints 	Integer 	1 			Little
Byte 44 	Parts 			Parts 		Integer 	NumParts 	Little
Byte X 		Points 			Points 		Point 	NumPoints 	Little
Note: X = 44 + 4 * NumParts
"

	| stream source |
	source := self.	"to test, obtain data from the receiver. source is assumed to be a ShapeMap !!!!!!"
	stream := WriteStream on: (ByteArray new: 10000).	"10000 bytes to start with"
	1 to: source numberOfShapes do: [:index |  | nPa nPo v | 
	"write record header"
	self on: stream putNextULong: index bigEndian: true.										"4 Bytes (Record Number)"	
	self on: stream putNextULong: (source recordSizeForShapeIndex: index) bigEndian: true.	"4 Bytes (Record Contents in 16bits words)"	

	"write record contents"
	self on: stream putNextULong: source shapeType bigEndian: false.			"4 Bytes (ShapeType)"
	self on: stream putNextDouble: (source xMinForShapeIndex: index) bigEndian: false.	"8 Bytes"
	self on: stream putNextDouble: (source yMinForShapeIndex: index) bigEndian: false.	"8 Bytes"
	self on: stream putNextDouble: (source xMaxForShapeIndex: index) bigEndian: false.	"8 Bytes"
	self on: stream putNextDouble: (source yMaxForShapeIndex: index) bigEndian: false.	"8 Bytes"
	nPa := source numPartsForShapeIndex: index.
	self on: stream putNextULong: nPa bigEndian: false.		"4 Bytes (numParts)".	
	nPo := source numPointsForShapeIndex: index.
	self on: stream putNextULong: nPo bigEndian: false.		"4 Bytes (tot number of points)".	
	nPa timesRepeat: [self on: stream putNextULong: 0 bigEndian: false].		"numParts * 4 Bytes"
	v := source verticesByPartsForShapeIndex: index. 
	v do: [:each | each do: [:vert | self on: stream putNextDouble: vert x bigEndian: false. self on: stream putNextDouble: vert y bigEndian: false]] 
	].

	^stream contents! !

!PolygonShape methodsFor: 'accessing - bytes' stamp: 'jmb 1/12/2006 17:35'!
subHeaderBytesForShapeIndex: anInteger
	"answer the Bytes of the shape record that appear between the actual header and the points collection"

	| offset |
	offset := (self byteOffsetForShapeAtIndex: anInteger) + 8. "skip the record header"
	^shpBytes copyFrom: offset
		to: offset - 1 + 44 + (4 * (self numPartsForShapeIndex: anInteger ) )! !

!PolygonShape methodsFor: 'accessing - bytes' stamp: 'jmb 1/12/2006 17:47'!
subHeaderForShapeIndex: anInteger
	"answer the data in the shape record that appear between the actual header and the points collection"


	| bytes all |
	bytes := self subHeaderBytesForShapeIndex: anInteger.
	all := OrderedCollection new.
	all addLast: (bytes longAt: 1 bigEndian: false).		"ShapeType"
	all addLast: (bytes doubleAt: 5 bigEndian: false).		"xMin"
	all addLast: (bytes doubleAt: 13 bigEndian: false).	"yMin"
	all addLast: (bytes doubleAt: 21 bigEndian: false).
	all addLast: (bytes doubleAt: 29 bigEndian: false).

	all addLast: (bytes longAt: 37 bigEndian: false).	"nr of parts"
	all addLast: (bytes longAt: 41 bigEndian: false).	"nr of points"

	1 to: (bytes size - 44) / 4 do: [:i |
			all addLast: (bytes longAt: 45 + ((i-1)*4) bigEndian: false)].	"each part takes 4 bytes (but the value seems to be always 0?)"

	^all asArray! !

!PolygonShape methodsFor: 'writing' stamp: 'jmb 1/12/2006 23:04'!
testWriting
	"answer the difference between a copy of the shapes-bytes and shapes-bytes generated by
	extracting data from the receiver and writing this data on a binary stream"

	| streamed copied n test |
	streamed := self streamedShapesBytes.
	copied := self shapesBytes.
	n := streamed size.
"	test := ByteArray new: n.
	1 to: n do: [:i | test at: i put: ((streamed at:i) = (copied at:i) ifFalse: [1] ifTrue: [0])].
"
	test := Dictionary new.
	1 to: n do: [:i | (streamed at:i) = (copied at:i) ifFalse: [test at: i put: ((streamed at:i) -> (copied at:i))]].

	^test! !

!PolygonShape methodsFor: 'accessing - shape by index' stamp: 'jmb 11/25/2004 13:48'!
vertices2DByPartsForShapeIndex: anInteger 
	"extract collections of vertices for all parts of shape index anInteger"
	"identical to #verticesByPartsForShapeIndex: anInteger"

	^self 
		verticesByPartsForShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

!PolygonShape methodsFor: 'accessing - records' stamp: 'jmb 1/12/2006 16:27'!
verticesByPartsForShapeAtOffset: anInteger 
	| offsets nRings n vOffset ends result |
	offsets := self partsOffsetsForShapeAtOffset:anInteger. 
	n := self numPointsForShapeAtOffset: anInteger.
	nRings := offsets size.
	ends := OrderedCollection new: nRings.
	1 to: nRings - 1 do: [:i | ends addLast: ((offsets at: i + 1) - 1)].	"1 to: 0 do: [:i | self halt]"
	ends addLast: n.
	ends := ends asArray.
	result := Array new: nRings.
	vOffset := anInteger + 52 + (4 * nRings).	"add the 8-byte header + the 4-byte shapeType + 4*8-byte Box + 4-byte numParts + 4-byte numPoints + nRings*4-byte"
	1 to: nRings do: [:i | | vertices | vertices := OrderedCollection new: ((ends at: i) + 1 - (offsets at: i)).
		(offsets at: i) to: (ends at: i) do: [:j | vertices addLast: 
			("shpBytes doubleAt:" self shpDoubleAt: vOffset + (j - 1 * 16) bigEndian: false) 
			@ 
			("shpBytes doubleAt:" self shpDoubleAt: vOffset + (j - 1 * 16) + 8 bigEndian: false)].
		result at: i put: vertices asArray].
	^result! !

!PolygonShape methodsFor: 'accessing - shape by index' stamp: 'jmb 4/27/2004 13:09'!
verticesByPartsForShapeIndex: anInteger 
	"extract collections of vertices for all parts of shape index anInteger"

	^self 
		verticesByPartsForShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

!PolygonShape methodsFor: 'accessing - records' stamp: 'jmb 1/12/2006 15:36'!
xMaxForShapeAtOffset: anInteger 
	"xMax"
	^self shpDoubleAt: anInteger + 28 bigEndian: false! !

!PolygonShape methodsFor: 'accessing - shape by index' stamp: 'jmb 1/12/2006 15:37'!
xMaxForShapeIndex: anInteger 
	"xMax in boundingBox of shape record anInteger"
	^ self
		xMaxForShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

!PolygonShape methodsFor: 'accessing - records' stamp: 'jmb 1/12/2006 15:35'!
xMinForShapeAtOffset: anInteger 
	"xMin"
	^self shpDoubleAt: anInteger + 12 bigEndian: false! !

!PolygonShape methodsFor: 'accessing - shape by index' stamp: 'jmb 1/12/2006 15:37'!
xMinForShapeIndex: anInteger 
	"xMin in boundingBox of shape record anInteger"
	^ self
		xMinForShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

!PolygonShape methodsFor: 'accessing - records' stamp: 'jmb 1/12/2006 15:36'!
yMaxForShapeAtOffset: anInteger 
	"yMax"
	^self shpDoubleAt: anInteger + 36 bigEndian: false! !

!PolygonShape methodsFor: 'accessing - shape by index' stamp: 'jmb 1/12/2006 15:38'!
yMaxForShapeIndex: anInteger 
	"yMax in boundingBox of shape record anInteger"
	^ self
		yMaxForShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

!PolygonShape methodsFor: 'accessing - records' stamp: 'jmb 1/12/2006 15:36'!
yMinForShapeAtOffset: anInteger 
	"yMin"
	^self shpDoubleAt: anInteger + 20 bigEndian: false! !

!PolygonShape methodsFor: 'accessing - shape by index' stamp: 'jmb 1/12/2006 15:37'!
yMinForShapeIndex: anInteger 
	"yMin in boundingBox of shape record anInteger"
	^ self
		yMinForShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

PolygonShape subclass: #PolygonZShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shapes-Base'!

!PolygonZShape commentStamp: '<historical>' prior: 0!
PolygonZShape represents a PolygonZ type of Shapefile. It contains Z values and (optional) measures M


Position		Field			Value		Type	Number		ByteOrder
Byte 0 		Shape Type 		15 			Integer 	1 			Little
Byte 4 		Box 			Box 		Double 	4 			Little
Byte 36 		NumParts 		NumParts 	Integer 	1 			Little
Byte 40 		NumPoints 		NumPoints 	Integer 	1 			Little
Byte 44 		Parts 			Parts 		Integer 	NumParts 	Little
Byte X 		Points 			Points 		Point 	NumPoints 	Little
Byte Y 		Zmin 			Zmin 		Double 	1 			Little
Byte Y + 8 	Zmax 			Zmax 		Double 	1 			Little
Byte Y + 16 Zarray 			Zarray 		Double 	NumPoints 	Little
Byte Z* 		Mmin 			Mmin 		Double 	1 			Little
Byte Z+8* 	Mmax 			Mmax 		Double 	1 			Little
Byte Z+16* 	Marray 		Marray 	Double 	NumPoints 	Little
Note: X = 44 + (4 * NumParts), Y = X + (16 * NumPoints), Z = Y + 16 + (8 * NumPoints)
* optional
!

!PolygonZShape class methodsFor: 'instance creation' stamp: 'jmb 7/8/2009 14:53'!
fromOutlineVertsColl: vertsColl boundingBox: aRectangle

	^self error: 'not yet implemented'! !

!PolygonZShape class methodsFor: 'instance creation' stamp: 'jmb 7/8/2009 14:53'!
fromVertsColl: aColl boundingBox: aRectangle

	^self error: 'not yet implemented'! !

!PolygonZShape class methodsFor: 'accessing' stamp: 'jmb 7/4/2008 17:04'!
shapeType
	^15
"
0	Null Shape
1	Point
3	PolyLine
5	Polygon
8	MultiPoint
11	PointZ
13	PolyLineZ
15	PolygonZ
18	MultiPointZ
21	PointM
23	PolyLineM
25	PolygonM
28	MultiPointM
31	MultiPatch
"! !

!PolygonZShape methodsFor: 'accessing - contents' stamp: 'jmb 11/25/2004 22:25'!
shapes
	"answer the receiver's data as anArray with Arrays with Points"
	| n shapes |
	n := self numberOfShapes.
	shapes := Array new: n.
	1
		to: n
		do: [:i | shapes
				at: i
				put: (self verticesByPartsForShapeIndex: i)].
	^ shapes! !

!PolygonZShape methodsFor: 'accessing - shape by index' stamp: 'jmb 11/25/2004 13:50'!
vertices2DByPartsForShapeIndex: anInteger 
	"extract collections of vertices for all parts of shape index anInteger"
	"that's precisely what the superclass does (ignoring Z values)"

	^super verticesByPartsForShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

!PolygonZShape methodsFor: 'accessing - records' stamp: 'jmb 12/3/2004 13:04'!
verticesByPartsForShapeAtOffset: anInteger 
	"answers anArray with vertices (each vertex anArray(x y z)) organised per part (in an Array).
	Thus, anArray with Arrays with Arrays"
	"alternatively, create B3DVector3s instead of Arrays to represent 3D points"
	
	| offsets nRings n vOffset ends result zOffset |
	offsets := self partsOffsetsForShapeAtOffset: anInteger.
	n := self numPointsForShapeAtOffset: anInteger.
	nRings := offsets size.
	ends := OrderedCollection new: nRings.
	1
		to: nRings - 1
		do: [:i | ends addLast: (offsets at: i + 1)
					- 1].
	ends addLast: n.
	ends := ends asArray.
	result := Array new: nRings.
	vOffset := anInteger + 52 + (4 * nRings).
	"add the 8-byte header + the 4-byte shapeType + 4*8-byte Box + 4-byte 
	numParts + 4-byte numPoints + nRings*4-byte"
	zOffset := vOffset + (16 * n) + 16. "skip zMin and zMax"
	1
		to: nRings
		do: [:i | 
			| vertices | 
			vertices := OrderedCollection new: (ends at: i)
							+ 1
							- (offsets at: i).
			(offsets at: i)
				to: (ends at: i)
				do: [:j | vertices addLast: (Array 
							with: ("shpBytes doubleAt:" self shpDoubleAt: vOffset + (j - 1 * 16) bigEndian: false)
							with: ("shpBytes doubleAt:" self shpDoubleAt: vOffset + (j - 1 * 16) + 8 bigEndian: false)
							with: ("shpBytes doubleAt:" self shpDoubleAt: zOffset + (j - 1 * 8) bigEndian: false))].
			result at: i put: vertices asArray].
	^ result! !

!PolygonZShape methodsFor: 'accessing - records' stamp: 'jmb 12/3/2004 13:05'!
zMaxForShapeAtOffset: anInteger 
	"answer the zMax value of the shape whose record starts at Byte anInteger "

	| nPoints nParts offset |
	nParts := shpBytes longAt: anInteger + 8 + 36 bigEndian: false.
	nPoints := shpBytes longAt: anInteger + 8 + 40 bigEndian: false.
	offset := anInteger + 8 + 44 + (4 * nParts) + (16 * nPoints).
	^ "shpBytes doubleAt:" self shpDoubleAt: offset + 8 bigEndian: false! !

!PolygonZShape methodsFor: 'accessing - shape by index' stamp: 'jmb 11/25/2004 14:00'!
zMaxForShapeIndex: anInteger
	^self zMaxForShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

!PolygonZShape methodsFor: 'accessing - records' stamp: 'jmb 12/3/2004 13:03'!
zMinForShapeAtOffset: anInteger 
	"answer the zMin value of the shape whose record starts at Byte anInteger "

	| nPoints nParts offset |
	nParts := shpBytes longAt: anInteger + 8 + 36 bigEndian: false.
	nPoints := shpBytes longAt: anInteger + 8 + 40 bigEndian: false.
	offset := anInteger + 8 + 44 + (4 * nParts) + (16 * nPoints).
	^ "shpBytes doubleAt:" self shpDoubleAt: offset bigEndian: false! !

!PolygonZShape methodsFor: 'accessing - shape by index' stamp: 'jmb 11/25/2004 14:00'!
zMinForShapeIndex: anInteger
	^self zMinForShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

!PolygonZShape methodsFor: 'accessing - records' stamp: 'jmb 12/3/2004 13:06'!
zMinMaxForShapeAtOffset: anInteger 
	"answer the zMin@zMax value of the shape whose record starts at Byte anInteger "

	| nPoints nParts offset |
	nParts := shpBytes longAt: anInteger + 8 + 36 bigEndian: false.
	nPoints := shpBytes longAt: anInteger + 8 + 40 bigEndian: false.
	offset := anInteger + 8 + 44 + (4 * nParts) + (16 * nPoints).
	^ ("shpBytes doubleAt:" self shpDoubleAt: offset bigEndian: false) 
	@ ("shpBytes doubleAt:" self shpDoubleAt: offset + 8 bigEndian: false)! !

!PolygonZShape methodsFor: 'accessing - shape by index' stamp: 'jmb 11/25/2004 14:01'!
zMinMaxForShapeIndex: anInteger
	^self zMinMaxForShapeAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

PolygonZShape subclass: #PolyLineZShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shapes-Base'!

!PolyLineZShape commentStamp: '<historical>' prior: 0!
PolyLineZShape represents a PolyLineZ Type shape file.

Structure is identical to PolygonZShape!

!PolyLineZShape class methodsFor: 'accessing' stamp: 'jmb 7/4/2008 17:04'!
shapeType
	^13
"
0	Null Shape
1	Point
3	PolyLine
5	Polygon
8	MultiPoint
11	PointZ
13	PolyLineZ
15	PolygonZ
18	MultiPointZ
21	PointM
23	PolyLineM
25	PolygonM
28	MultiPointM
31	MultiPatch
"! !

!PolyLineZShape methodsFor: 'accessing' stamp: 'jmb 3/22/2005 13:50'!
generalType

	^'PolyLine'! !

!PolyLineZShape methodsFor: 'testing' stamp: 'jmb 3/1/2005 11:11'!
hasLines
	^true! !

!PolyLineZShape methodsFor: 'testing' stamp: 'jmb 3/1/2005 11:10'!
hasPolygons
	^false! !

!PolyLineZShape methodsFor: 'displaying' stamp: 'jmb 11/25/2004 14:21'!
polygonColor
	"avoid polygons being filled with color (receiver does not define polygons!!)"
	
	^nil! !

PolygonShape subclass: #PolyLineShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shapes-Base'!

!PolyLineShape commentStamp: 'jmb 4/22/2005 16:28' prior: 0!
PolyLineShape represents a PolyLine Type shape file.

From the official documentation:
A PolyLine is an ordered set of vertices that consists of one or more parts. A part is a connected sequence of two or more points. Parts may or may not be connected to one another. Parts may or may not intersect one another.

(For details, see class PolygonShape, as the organization of PolyLine shapes is identical to that of Polygon shapes)

!

!PolyLineShape class methodsFor: 'instance creation' stamp: 'jmb 7/7/2009 14:54'!
fromVertsColl: aColl boundingBox: aRectangle 
	"create a complete PolyLineShape. Shapes may consist of multiple parts (that would be outline + holes vertices in case of a polygon shape)"


	"(
	self fromVertsColl:  		
				{ 
				{ {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 20. } .
				{ {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 50.  {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} reversed * 25 + (35@35). } .
				{ {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 20 + (25@0). } .
				{ {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 20 + (50@0). } .
				}
		boundingBox: (0@0 extent: 120@120)
	)
	drawForm"

	"(
	self fromVertsColl:  		
				{ 
				{ {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 20. } .
				{ {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 50. } .
				{ {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 20 + (25@0). } .
				{ {1.0@1.0. 1.0@2.0. 2.0@2.0. 2.0@1.0. 1.0@1.0.} * 20 + (50@0). } .
				}
		boundingBox: (0@0 extent: 120@120)
	)
	drawForm"

	^self new fromVertsColl: aColl boundingBox: aRectangle! !

!PolyLineShape class methodsFor: 'accessing' stamp: 'jmb 7/4/2008 17:04'!
shapeType
	^3
"
0	Null Shape
1	Point
3	PolyLine
5	Polygon
8	MultiPoint
11	PointZ
13	PolyLineZ
15	PolygonZ
18	MultiPointZ
21	PointM
23	PolyLineM
25	PolygonM
28	MultiPointM
31	MultiPatch
"! !

!PolyLineShape methodsFor: 'accessing' stamp: 'jmb 3/22/2005 13:50'!
generalType

	^'PolyLine'! !

!PolyLineShape methodsFor: 'testing' stamp: 'jmb 3/1/2005 11:09'!
hasLines
	^true! !

!PolyLineShape methodsFor: 'testing' stamp: 'jmb 3/1/2005 11:10'!
hasPolygons
	^false! !

!PolyLineShape methodsFor: 'displaying' stamp: 'jmb 4/21/2004 11:07'!
polygonColor
	"avoid polygons being filled with color (receiver does not define polygons!!)"
	
	^nil! !

!ShapeMap class methodsFor: 'sar' stamp: 'jmb 6/17/2008 09:09'!
createSAR
	"self createSAR"
	| sar |
	sar := Smalltalk at: #SARChangeSetDumper ifAbsent: [^nil].
	(sar on: Project current changeSet including: #())
		readmeText: ('a reader & viewer of GIS data in ESRI shapefile format.
Read a shapefile by e.g. shapefile := ShapeMap fromFile: ''yourShapeFileNameIncludingPath.shp''.
Convert it into a Form and display it by: shapefile drawForm.
Have fun!! Comments and enhancements appreciated.

Hans Baveco
' , Date today printString);
		fileOutAsZipNamed: 'shape1.1.sar'! !

!ShapeMap class methodsFor: 'examples' stamp: 'jmb 6/12/2008 16:24'!
examples
	"(ShapeMap fromFile: 'd:\etarcview\giovanna\navelli_cocullo.shp') displayMorphic"
	"(ShapeMap fromFile: 'd:\etarcview\varkens\giabvarkenslbt2001.shp') displayMorphic"
	"(ShapeMap fromFile: 'd:\etarcview\bushcricket\withET_CLASS\SmallSteps_B-HOE.shp') displayMorphic"
	"(ShapeMap fromFile: 'd:\etarcview\bushcricket\withET_CLASS\SmallSteps_B-HOE_line.shp') displayMorphic"
	"(ShapeMap fromFile: 'd:\etarcview\bushcricket\withET_CLASS\SmallSteps_H_REE_line.shp') displayMorphic"
	"(ShapeMap fromFile: 'd:\etarcview\dasenweg\road99.shp') displayMorphic"	"not working..."
	"(ShapeMap fromFile: 'd:\etarcview\giovanna\uso_corr.shp') displayMorphic"
	"(ShapeMap fromFile: 'd:\etarcview\giovanna\abarr.shp') displayMorphic"
	"(ShapeMap fromFile: 'c:\esri\esridata\CANADA\province.shp') displayMorphic "
	"(ShapeMap fromFile: 'c:\esri\esridata\USA\cities.shp') displayMorphic "
	"(ShapeMap fromFile: 'c:\esri\esridata\world\cities.shp') displayMorphic "
	"(ShapeMap fromFile: 'c:\esri\esridata\europe\country.shp') displayMorphic "		
	"(ShapeMap fromFile: 'C:\ESRI\AV_GIS30\AVTUTOR\ARCVIEW\qstart\world94.shp') displayMorphic "
	"(ShapeMap fromFile: 'C:\ESRI\AV_GIS30\AVTUTOR\SPATIAL\pop.shp') displayMorphic "
	"(ShapeMap fromFile: 'C:\ESRI\AV_GIS30\AVTUTOR\SPATIAL\lifstyle.shp') displayMorphic "
	"(ShapeMap fromFile: 'C:\ESRI\AV_GIS30\AVTUTOR\ARCVIEW\qstart\attract.shp') displayMorphic "
	"(ShapeMap fromFile: 'd:\etarcview\3D\abr-z.shp') displayMorphic"			
	
! !

!ShapeMap class methodsFor: 'instance creation' stamp: 'jmb 1/9/2006 12:46'!
fromBytes: aShpBytes 
	"create a new instance of the appropriate subclass of ShapeMap.
	The instance will act as a wrapper of the raw bytes (stored in ShpBytes)"

	"in case of different types (subclasses), select the relevant one here"

	"ESRI shape file types include:
0	Null Shape
1	Point
3	PolyLine
5	Polygon
8	MultiPoint
11	PointZ
13	PolyLineZ
15	PolygonZ
18	MultiPointZ
21	PointM
23	PolyLineM
25	PolygonM
28	MultiPointM
31	MultiPatch
	Types > 20 are not yet accounted for"

	| instance type theClass |
	type := aShpBytes longAt: 33 bigEndian: false.
	(type // 10) = 0 ifTrue: ["no Z, no M"
		(type \\ 10) = 1 ifTrue: [theClass := PointShape]. 
		(type \\ 10) = 3 ifTrue: [theClass := PolyLineShape]. 	
		(type \\ 10) = 5 ifTrue: [theClass := PolygonShape].
		(type \\ 10) = 8 ifTrue: [theClass := MultiPointShape]].
	(type // 10) = 1 ifTrue: ["with Z, optional M"
		(type \\ 10) = 1 ifTrue: [theClass := PointZShape]. 
		(type \\ 10) = 3 ifTrue: [theClass := PolyLineZShape]. 	
		(type \\ 10) = 5 ifTrue: [theClass := PolygonZShape].
		(type \\ 10) = 8 ifTrue: [theClass := MultiPointZShape]].
	theClass isNil ifTrue: [^self halt "not accounted for yet" ].
	instance := theClass new.
	instance setBytes: aShpBytes.
	^instance! !

!ShapeMap class methodsFor: 'instance creation' stamp: 'jmb 6/17/2008 09:01'!
fromFile: aString 
	"create ShapeMap from the bytes read from file aString"
	"ShapeMap fromFile: 'c:\etarcview\giovanna\navelli_cocullo.shp'"
	"ShapeMap fromFile: 'c:\etarcview\varkens\giabvarkenslbt2001.shp'"
	"ShapeMap fromFile: 'c:\etarcview\bushcricket\SmallSteps_B-HOE.shp'"
	"ShapeMap fromFile: 'c:\etarcview\bushcricket\SmallSteps_B-HOE_line.shp'"
	"ShapeMap fromFile: 'c:\etarcview\bushcricket\SmallSteps_H-REE_line.shp'"
	"ShapeMap fromFile: 'c:\etarcview\dasenweg\road99.shp'"
	"ShapeMap fromFile: 'c:\etarcview\giovanna\uso_corr.shp'"
	"ShapeMap fromFile: 'c:\etarcview\giovanna\abarr.shp'"
	"ShapeMap fromFile: 'c:\esri\testarc.shp'"
	"ShapeMap fromFile: 'c:\esri\testpoint.shp'"
	"ShapeMap fromFile: 'c:\esri\esridata\CANADA\province.shp' "
	"ShapeMap fromFile: 'c:\esri\esridata\USA\cities.shp' "
	"ShapeMap fromFile: 'c:\esri\esridata\world\cities.shp' "
	"ShapeMap fromFile: 'c:\esri\esridata\europe\country.shp' "
	"ShapeMap fromFile: 'c:\esri\otherdata\tlhart.shp' "
	"ShapeMap fromFile: 'c:\esri\otherdata\shore.shp' "
	"ShapeMap fromFile: 'C:\ESRI\AV_GIS30\arcview\Samples\test\uscities\ci10de03.shp' "				
	"ShapeMap fromFile: 'C:\ESRI\AV_GIS30\arcview\Samples\SArcView\SCarolina\p90new.shp' "
	"ShapeMap fromFile: 'C:\ESRI\AV_GIS30\arcview\Samples\test\hydrology\rf19fe99.shp' "
	"ShapeMap fromFile: 'C:\ESRI\AV_GIS30\arcview\Samples\test\marinezones\hz02oc01.shp' "	
	"ShapeMap fromFile: 'd:\etarcview\3D\poultry3D.shp'"			
	"ShapeMap fromFile: 'd:\etarcview\3D\abr-z.shp'"			
	
	| stream instance tail shxStream shxBytes dir shpFileString |
	dir := FileDirectory forFileName: aString. 
	stream := (dir readOnlyFileNamed: aString) binary.
	instance := self
				fromBytes: ([stream contents]
						ensure: [stream close]).
	shpFileString := aString.
	tail := shpFileString copyFrom: 1 to: shpFileString size - 4.
	instance label: tail.
	(dir fileExists: tail , '.shx') ifFalse: [self error: 'missing shx file. Proceed to continue without...'. ^ instance].
	shxStream := (dir readOnlyFileNamed: tail , '.shx') binary.
	shxBytes := [shxStream contents]
				ensure: [shxStream close].
	instance shxBytes: shxBytes.
	^ instance! !

!ShapeMap class methodsFor: 'instance creation' stamp: 'jmb 6/17/2008 09:01'!
shapesFromFile: aString 
	"extract all shapes from file aString"
	"ShapeMap shapesFromFile: 'd:\3D\abr-z.shp' "
	"ShapeMap shapesFromFile: 'c:\etshapes\giabvarkenslbt2001\giabvarkenslbt2001.shp' "
		
	| inst |
	inst := self fromFile: aString.
	inst isNil ifFalse: [^inst shapes].
	^inst! !

!ShapeMap class methodsFor: 'accessing' stamp: 'jmb 7/4/2008 17:02'!
shapeType
	"each type has a typical number"

	^self subclassResponsibility! !

!ShapeMap methodsFor: 'accessing - index' stamp: 'jmb 4/27/2004 10:17'!
allShapeRecordByteOffsets
	"collect all the offsets as they can be used to query the shpBytes"
	"so NOT zero-based but one-based count; NOT in 16-bit words but in Bytes"

	| n offsets |
	n := self numberOfShapes.
	offsets := Array new: n.
	1 to: n do: [:i | offsets at: i put: (self byteOffsetForShapeAtIndex: i)].
	^offsets! !

!ShapeMap methodsFor: 'accessing - index' stamp: 'jmb 1/12/2006 22:58'!
allShapeRecordOffsets
	"collect all the offsets (in words, zero-based) as they are stored in the shx.shp"

	| n offsets |
	n := self numberOfShapes.
	offsets := Array new: n.
	1 to: n do: [:i | offsets at: i put: (self offsetForShapeAtIndex: i)].
	^offsets! !

!ShapeMap methodsFor: 'displaying' stamp: 'jmb 4/27/2004 12:57'!
arcColor
	^ Color black! !

!ShapeMap methodsFor: 'converting' stamp: 'jmb 6/17/2008 08:58'!
asForm
	"answer a Form with the receiver drawn on it. The whole map is projected on the Form"

	"(ImageMorph new image: (ShapeMap fromFile: 'c:\esri\esridata\CANADA\province.shp') asForm) openInWorld"
	"(ImageMorph new image: (ShapeMap fromFile: 'c:\esri\esridata\europe\country.shp') asForm) openInWorld"

	| form |
	form := Form extent: self preferredFormExtent depth: Display depth.
	form fillWhite.
	self drawOn: (BalloonCanvas on: form).
	^form! !

!ShapeMap methodsFor: 'converting - morphic' stamp: 'jmb 4/22/2008 14:19'!
asShapeMorph
	"create a ShapeMorph holding the receiver"
	| shpMClass |
	shpMClass := Smalltalk at: #ShapeMorph ifAbsent: [^nil].
	^ shpMClass new shapeMap: self! !

!ShapeMap methodsFor: 'converting' stamp: 'jmb 4/22/2005 16:12'!
asSimpleVectorLandscape
	self subclassResponsibility! !

!ShapeMap methodsFor: 'displaying' stamp: 'jmb 4/27/2004 12:57'!
backgroundColor
	^Color r: 0.774 g: 0.903 b: 0.903! !

!ShapeMap methodsFor: 'accessing' stamp: 'jmb 4/20/2004 16:28'!
boundingBox
	^Rectangle origin: self xMin @ self yMin corner: self xMax @ self yMax! !

!ShapeMap methodsFor: 'accessing - index' stamp: 'jmb 4/27/2004 10:17'!
byteOffsetForShapeAtIndex: anInteger 
	"answer the offset (for the record of shape number anInteger in the main file) in number of Bytes from the start of the main file"

	"Note that the result is now based on count starting with ONE!!"

	^(self offsetForShapeAtIndex: anInteger)  * 2 + 1! !

!ShapeMap methodsFor: 'displaying' stamp: 'jmb 6/9/2008 17:22'!
colors: anArray
	"defines the colors of the shapes (anArray size = nr of shapes!!)"

	colors := anArray! !

!ShapeMap methodsFor: 'writing' stamp: 'jmb 11/24/2008 11:26'!
copyToFile
	"ask the user for a (shape) file name and dump the shpBytes and shxBytes"
	"default, the associated dbf file is also copied to newName.dbf"

	"(ShapeMap fromFile: 'd:\etarcview\giovanna\navelli_cocullo.shp') copyToFile "

	|  newName |
	newName := FillInTheBlank
		request: 'New File Name?' translated
		initialAnswer: 'test'.
	newName isEmpty ifTrue: [^self].
	self copyToFile: newName! !

!ShapeMap methodsFor: 'writing' stamp: 'jmb 11/24/2008 11:08'!
copyToFileInDir: aDirString 
	"ask the user for a (shape) file name and dump the shpBytes, shxBytes and dbf bytes"

	"the user should make sure the directory actually exists!!"

	"(ShapeMap fromFile: 'd:\etarcview\giovanna\navelli_cocullo.shp') copyToFileInDir: 'd:\squeak3\temp' "

	| newName dir fullName |
	newName := FillInTheBlank request: 'New File Name?' translated
				initialAnswer: 'test'.
	dir := FileDirectory new directoryNamed: aDirString.
	fullName := dir pathName , FileDirectory slash , newName.
	self copyToFile: fullName! !

!ShapeMap methodsFor: 'writing' stamp: 'jmb 11/24/2008 11:20'!
copyToFileInDir: aDirString dbf: aDBF
	"ask the user for a (shape) file name and dump the shpBytes and shxBytes.
	The dbf bytes in aDBF are dumped as well"

	"(ShapeMap fromFile: 'd:\etarcview\giovanna\navelli_cocullo.shp') copyToFileInDir: 'd:\squeak3\temp' dbf: (DBF on: 'd:\etarcview\giovanna\navelli_cocullo.dbf')"

	| newName dir fullName |
	newName := FillInTheBlank request: 'New File Name?' translated
				initialAnswer: 'test'.
	dir := FileDirectory new directoryNamed: aDirString.
	fullName := dir pathName , FileDirectory slash , newName.
	self copyToFileNoDBF: fullName.

	aDBF dbfBytesToFile: fullName , '.dbf'! !

!ShapeMap methodsFor: 'writing' stamp: 'jmb 11/24/2008 11:13'!
copyToFileNoDBF
	"ask the user for a (shape) file name and dump the shpBytes & shxBytes only"

	"(ShapeMap fromFile: 'd:\etarcview\giovanna\navelli_cocullo.shp') copyToFile "

	|  newName |
	newName := FillInTheBlank
		request: 'New File Name?' translated
		initialAnswer: 'test'.
	newName isEmpty ifTrue: [^self].
	self copyToFileNoDBF: newName! !

!ShapeMap methodsFor: 'writing' stamp: 'jmb 11/24/2008 11:11'!
copyToFileNoDBF: newName
	"dump the shpBytes and shxBytes on files newName.shp and newName.shx"

	"(ShapeMap fromFile: 'd:\etarcview\giovanna\navelli_cocullo.shp') copyToFileNoDBF: 'd:\etarcview\atestshape2' "

	| dir aString stream aString2 stream2 |
	dir := FileDirectory default.

	aString :=  dir fullNameFor: (newName , '.shp'). 
	stream := (dir newFileNamed: aString) binary.
	[stream next: shpBytes basicSize putAll: shpBytes]
						ensure: [stream close].

	aString2 :=  dir fullNameFor: (newName , '.shx'). 
	stream2 := (dir newFileNamed: aString2) binary.
	[stream2 next: shxBytes basicSize putAll: shxBytes]
						ensure: [stream2 close]! !

!ShapeMap methodsFor: 'writing' stamp: 'jmb 7/3/2009 13:58'!
copyToFile: newName 
	"dump the shpBytes and shxBytes on files newName.shp and newName.shx"

	"a dbf file with the receiver's shape name should exist. It is read and also copied to newName.dbf"

	"(ShapeMap fromFile: 'd:\etarcview\giovanna\navelli_cocullo.shp') copyToFile: 'd:\etarcview\atestshape2' "

	| dir aString stream aString2 stream2 dbfBytes aString3 stream3 |
	dir := FileDirectory default.
	aString := dir fullNameFor: newName , '.shp'.
	stream := (dir newFileNamed: aString) binary.
	[stream next: shpBytes basicSize putAll: shpBytes] ensure: [stream close].

	aString2 := dir fullNameFor: newName , '.shx'.
	stream2 := (dir newFileNamed: aString2) binary.
	[stream2 next: shxBytes basicSize putAll: shxBytes] 
		ensure: [stream2 close].

	Smalltalk at: #XBaseFile ifAbsent: [^self].
	(label notNil and: [dir fileExists: label , '.dbf']) 
		ifFalse: [^self writeMiniMinimalDBF: newName , '.dbf'].	"create a minimal dbf"
	dbfBytes := XBaseFile dbfBytesFrom: label , '.dbf'.	"the bytes are read into memory, and directly written to the newName.dbf file"
	aString3 := dir fullNameFor: newName , '.dbf'.
	stream3 := (dir newFileNamed: aString3) binary.
	[stream3 next: dbfBytes basicSize putAll: dbfBytes] 
		ensure: [stream3 close]! !

!ShapeMap methodsFor: 'displaying' stamp: 'jmb 6/12/2008 16:53'!
display
	"show on the Display"

	^self asForm displayOn: Display! !

!ShapeMap methodsFor: 'displaying' stamp: 'jmb 6/12/2008 15:57'!
displayMorphic
	"open an ImageMorph with the receiver as an image"

	^(ImageMorph new image: self asForm) openInWorld! !

!ShapeMap methodsFor: 'displaying - morphic' stamp: 'jmb 3/8/2005 09:52'!
draw
	^self asShapeMorph openInWorld! !

!ShapeMap methodsFor: 'displaying - morphic' stamp: 'jmb 6/17/2008 09:13'!
drawForm
	"draw receiver on a Form and show the form"

	| imageMorph |
	imageMorph := self asForm asMorph.
	imageMorph isOpaque: true.
	imageMorph openInWorld! !

!ShapeMap methodsFor: 'displaying' stamp: 'jmb 7/8/2009 15:15'!
drawOn: aCanvas 
	"draw the shape in default colors (no legend using information from the dbf is required)"
	| canvas geoBB scaling m multiplier xMin yMax rect polygonColor arcColor pointColor |

	canvas := aCanvas asBalloonCanvas.
	canvas aaLevel: 4.

	"boundingBox & scale"
	geoBB := self boundingBox.
	xMin := geoBB origin x.
	yMax := geoBB corner y.
	scaling := self preferredScaling.

	"if we have a legend, let it calculate all colors at once"
	"legend isNil ifFalse: [colors := legend colorForAll: (data collect: [:each | each at: coloringAttrIndex ]) ]. "

	polygonColor := self polygonColor.
	polygonColor isNil ifFalse: [polygonColor := polygonColor alpha: 0.5].
	arcColor := self arcColor.
	pointColor := self pointColor.

	"NOTE: for shapes where decimals values of the coordinates matter (small
	scale, eg hundreds), the result will be too coarse, due to truncation of 
	floating point values being done before scaling. Simple solution is 
	multiplication of the coordinates by eg 1000.0 while dividing the scale 
	by 1000.0"
	"calculate the transform"
	scaling > 1.0
		ifTrue: [multiplier := 1000.0.
			m := MatrixTransform2x3 withScale: 1 @ -1 * scaling / multiplier]
		ifFalse: [multiplier := 1.0.
			m := MatrixTransform2x3 withScale: 1 @ -1 * scaling].
	m offset: xMin negated @ yMax * scaling.
	canvas transformBy: m.
	"finally, the drawing-on-canvas code; slightly different depending on shapeMap type"
	self hasPolygons
		ifTrue: [1
				to: self numberOfShapes
				do: [:i | 
					| contours | 
					contours := self vertices2DByPartsForShapeIndex: i.
					scaling > 1.0
						ifTrue: [contours := contours
										collect: [:each | each
												collect: [:point | point * multiplier]]].
					(colors isNil or: [colors isEmpty]) ifFalse: [polygonColor := colors at: i].
					canvas
						drawGeneralPolygon: contours
						color: polygonColor
						borderWidth: 1
						borderColor: arcColor]].
	"+++++++++++ line shapes ++++++++++++++++++++++++"
	self hasLines
		ifTrue: [1
				to: self numberOfShapes
				do: [:i | 
					| contours | 
					contours := self vertices2DByPartsForShapeIndex: i.
					scaling > 1.0
						ifTrue: [contours := contours
										collect: [:each | each
												collect: [:point | point * multiplier]]].
					colors isNil ifFalse: [arcColor := colors at: i].
					canvas
						drawGeneralPolygon: contours
						color: nil
						borderWidth: 1
						borderColor: arcColor]].
	"+++++++++++ point shapes ++++++++++++++++++++++++"
	self hasPoints
		ifTrue: [rect := (Rectangle origin: -1.0 @ -1.0 corner: 1.0 @ 1.0)
						scaleBy: (10 raisedToInteger: (1.0 / (scaling / multiplier) max: 1.0) log truncated).
			self hasMultiPoints
				ifTrue: [1
						to: self numberOfShapes
						do: [:i | 
							| points | 
							points := self multiPointsFromShapeIndex: i.
							colors isNil ifFalse: [pointColor := colors at: i].
							scaling > 1.0
								ifTrue: [points := points
												collect: [:each | each * multiplier].
									points
										do: [:point | canvas
												drawRectangle: (rect translateBy: point)
												color: pointColor
												borderWidth: 0
												borderColor: nil]]]]
				ifFalse: [1
						to: self numberOfShapes
						do: [:i | 
							| point | 
							point := self point2DFromShapeIndex: i.
							scaling > 1.0
								ifTrue: [point := point * multiplier].
							colors isNil ifFalse: [pointColor := colors at: i].
							canvas
								drawRectangle: (rect translateBy: point)
								color: pointColor
								borderWidth: 0
								borderColor: nil]]]! !

!ShapeMap methodsFor: 'accessing - header' stamp: 'jmb 4/27/2004 10:17'!
fileCode
	"position 0, Integer, Big Endian"

	^shpBytes longAt: 1 bigEndian: true! !

!ShapeMap methodsFor: 'editing - header' stamp: 'jmb 1/13/2006 16:50'!
fileCode: anInteger
	"position 0, Integer, Big Endian. Always 9994"

	^shpBytes longAt: 1 put: 9994 bigEndian: true! !

!ShapeMap methodsFor: 'accessing - header' stamp: 'jmb 4/27/2004 10:17'!
fileLength
	"position 24, Integer, Big Endian"
	"total length of the file in 16-bit words (including the fifty 16-bit words that make up the file header"

	^shpBytes longAt: 25 bigEndian: true! !

!ShapeMap methodsFor: 'editing - header' stamp: 'jmb 1/13/2006 16:52'!
fileLength: anInteger
	"position 24, Integer, Big Endian"
	"total length of the file in 16-bit words (including the fifty 16-bit words that make up the file header"

	^shpBytes longAt: 25 put: anInteger bigEndian: true! !

!ShapeMap methodsFor: 'accessing' stamp: 'jmb 3/22/2005 13:48'!
generalType
	"subclass answer 'Point', 'Polygon' or 'PolyLine' "

	^self subclassResponsibility! !

!ShapeMap methodsFor: 'testing' stamp: 'jmb 3/1/2005 11:07'!
hasLines
	^false! !

!ShapeMap methodsFor: 'testing' stamp: 'jmb 3/8/2005 09:57'!
hasMultiPoints
	^false! !

!ShapeMap methodsFor: 'testing' stamp: 'jmb 3/1/2005 11:07'!
hasPoints
	^false! !

!ShapeMap methodsFor: 'testing' stamp: 'jmb 3/1/2005 11:07'!
hasPolygons
	^false! !

!ShapeMap methodsFor: 'accessing - bytes' stamp: 'jmb 1/12/2006 17:01'!
headerBytes
	"answer the header part of the bytes" 

	^shpBytes copyFrom: 1 to: 100! !

!ShapeMap methodsFor: 'accessing - bytes' stamp: 'jmb 1/12/2006 17:23'!
headerBytesForShapeIndex: anInteger 
	"extract the header bytes for shape with index anInteger"
	| offset |
	offset := self byteOffsetForShapeAtIndex: anInteger.
	^shpBytes copyFrom: offset
		to: offset - 1 + 8! !

!ShapeMap methodsFor: 'accessing - index' stamp: 'jmb 1/12/2006 17:23'!
headerForShapeIndex: anInteger
	"answer the header in numbers (not bytes!!). First value is the index of the shape; second value record contents size in 16bit words"

	| bytes |
	bytes := self headerBytesForShapeIndex: anInteger.
	^Array with: (bytes longAt: 1 bigEndian: true) with: (bytes longAt: 5 bigEndian: true)! !

!ShapeMap methodsFor: 'accessing - index' stamp: 'jmb 4/27/2004 10:17'!
indexFileLength
	"position 24, Integer, Big Endian"
	"total length of the file in 16-bit words (including the fifty 16-bit words that make up the file header"

	^shxBytes longAt: 25 bigEndian: true! !

!ShapeMap methodsFor: 'accessing' stamp: 'jmb 4/18/2004 21:37'!
label
	"answer the shape file name (aString)"

	^label! !

!ShapeMap methodsFor: 'accessing' stamp: 'jmb 4/27/2004 10:16'!
label: aString
	"set the name of the shape (the file name, excluding the shp suffix)"

	label := aString! !

!ShapeMap methodsFor: 'accessing - header' stamp: 'jmb 12/3/2004 12:47'!
mMax
	"byte 92, Double, Little Endian"
	"may be undefined!!"

	"^shpBytes doubleAt: 93 bigEndian: false "
	
	^self shpDoubleAt: 93 bigEndian: false	! !

!ShapeMap methodsFor: 'accessing - header' stamp: 'jmb 12/3/2004 12:48'!
mMin
	"byte 84, Double, Little Endian"
	"may be undefined!!"

	"^shpBytes doubleAt: 85 bigEndian: false "
	
	^self shpDoubleAt: 85 bigEndian: false	! !

!ShapeMap methodsFor: 'accessing - records' stamp: 'jmb 1/12/2006 22:57'!
nextRecordOffsetForRecordAtOffset: anInteger 
	"answer the offset of the next record. Using this info we could ignore the index file"

	^(self totalRecordSizeForRecordAtOffset: anInteger) * 2 + anInteger! !

!ShapeMap methodsFor: 'accessing' stamp: 'jmb 11/24/2006 14:06'!
numberOfShapes
	"answer the total number of shapes in the Shape file"
	"what a shapefile contains, depends on the Shape Type. The index file is 
	identical for all Shape Types, though"
	^ self indexFileLength - 50 * 2 / 8	 "subtract header (50 16-bit words), convert to bytes (50*2), divide by 
	record size in bytes (8: four bytes for Offset and 4 for Content Length)"! !

!ShapeMap methodsFor: 'accessing - index' stamp: 'jmb 4/27/2004 10:17'!
offsetForShapeAtIndex: anInteger 
	"answer the offset (for the record of shape number anInteger in the main file) in number of 16-bits words from the start of the main file"

	"Note that the result is based on count starting with zero"
	"From the documentation:
	The offset of a record in the main file is the number of 16-bit words from the start of the main file to the first byte of the record header for the record. Thus, the offset for the first record in the main file is 50, given the 100-byte header."

	^shxBytes longAt: 101 + ((anInteger - 1) * 8) bigEndian: true! !

!ShapeMap methodsFor: 'writing - support' stamp: 'jmb 1/12/2006 14:17'!
on: aStream putNextDouble: number bigEndian: aBoolean 
	"convenience method"
	| bytes |
	bytes := ByteArray new: 8.
	bytes 
		doubleAt: 1
		put: number
		bigEndian: aBoolean.
	aStream next: 8 putAll: bytes! !

!ShapeMap methodsFor: 'writing - support' stamp: 'jmb 1/12/2006 14:20'!
on: aStream putNextLong: number bigEndian: aBoolean 
	"convenience method"

	| bytes |
	bytes := ByteArray new: 4.
	bytes 
		longAt: 1
		put: number
		bigEndian: aBoolean.
	aStream next: 4 putAll: bytes! !

!ShapeMap methodsFor: 'writing - support' stamp: 'jmb 1/12/2006 14:21'!
on: aStream putNextShort: number bigEndian: aBoolean 
	"convenience method"

	| bytes |
	bytes := ByteArray new: 2.
	bytes 
		shortAt: 1
		put: number
		bigEndian: aBoolean.
	aStream next: 2 putAll: bytes! !

!ShapeMap methodsFor: 'writing - support' stamp: 'jmb 1/12/2006 14:21'!
on: aStream putNextULong: number bigEndian: aBoolean 
	"convenience method"

	| bytes |
	bytes := ByteArray new: 4.
	bytes 
		unsignedLongAt: 1
		put: number
		bigEndian: aBoolean.
	aStream next: 4 putAll: bytes! !

!ShapeMap methodsFor: 'writing - support' stamp: 'jmb 1/12/2006 14:21'!
on: aStream putNextUShort: number bigEndian: aBoolean 
	"convenience method"

	| bytes |
	bytes := ByteArray new: 2.
	bytes 
		unsignedShortAt: 1
		put: number
		bigEndian: aBoolean.
	aStream next: 2 putAll: bytes! !

!ShapeMap methodsFor: 'displaying' stamp: 'jmb 4/27/2004 12:58'!
pointColor
	^Color red! !

!ShapeMap methodsFor: 'displaying' stamp: 'jmb 4/27/2004 12:58'!
polygonColor
	^Color r: 0.903 g: 0.742 b: 0.387! !

!ShapeMap methodsFor: 'converting' stamp: 'jmb 4/22/2008 22:16'!
preferredFormExtent
	"derive the proportions from the geo-bounding box; use a preferred x-dimension in pixels"
	
	| gbb ext prop |
	gbb := self boundingBox.
	ext := gbb extent.
	prop := ext y / ext x.
	^1000 * (1@prop)! !

!ShapeMap methodsFor: 'converting' stamp: 'jmb 4/22/2008 22:30'!
preferredScaling
	"derive the scaling from the preferred extent in pixels"
	
	| gbb |
	gbb := self boundingBox.
	^1000.0 / gbb extent x.
! !

!ShapeMap methodsFor: 'accessing - bytes' stamp: 'jmb 1/12/2006 17:05'!
recordBytesForShapeIndex: anInteger 
	"extract the whole ByteArray constituting the complete record for shape with index anInteger"

	| offset |
	offset := self byteOffsetForShapeAtIndex: anInteger.
	^shpBytes copyFrom: offset
		to: offset - 1 + ((self totalRecordSizeForRecordAtOffset: offset) * 2)! !

!ShapeMap methodsFor: 'accessing - records' stamp: 'jmb 1/12/2006 17:18'!
recordNumberForRecordAtOffset: anInteger
	"answer the index of the shape contained in the record starting at offset anInteger"
	"Byte 1 to Byte 4 in the record header contain this Record Number"

	^shpBytes longAt: anInteger bigEndian: true.! !

!ShapeMap methodsFor: 'accessing - records' stamp: 'jmb 1/12/2006 17:06'!
recordSizeForRecordAtOffset: anInteger
	"answer record contents size (in 16-bit words) for record starting at offset anInteger"
	"Byte 5 to Byte 8 in the record header contain this Record Contents Size"

	^shpBytes longAt: anInteger + 4 bigEndian: true.! !

!ShapeMap methodsFor: 'accessing - index' stamp: 'jmb 1/12/2006 22:54'!
recordSizeForShapeIndex: anInteger
	"answer record contents size (in 16-bit words) for shape with index anInteger"

	^self recordSizeForRecordAtOffset: (self byteOffsetForShapeAtIndex: anInteger)! !

!ShapeMap methodsFor: 'private' stamp: 'jmb 4/27/2004 10:15'!
setBytes: aByteArray
	"store all the Bytes in shpBytes"

	shpBytes := aByteArray. "no need to copy the ByteArray, as done for UninterpretedBytes?"
	"self initializeFromHeaderInfo"! !

!ShapeMap methodsFor: 'accessing - contents' stamp: 'jmb 11/25/2004 21:36'!
shapes
	"answer the receiver's data as Squeak objects"
	"the context will determine the kind of objects needed.... Points, Arrays with Points, etc."
	
	self subclassResponsibility! !

!ShapeMap methodsFor: 'accessing - bytes' stamp: 'jmb 1/12/2006 21:43'!
shapesBytes
	"create the shape data bytes"

	^shpBytes copyFrom: 101 to: shpBytes size
! !

!ShapeMap methodsFor: 'accessing - header' stamp: 'jmb 4/27/2004 12:56'!
shapeType
	"position 32, Integer between 0 and 31, Little Endian"

	^shpBytes longAt: 33 bigEndian: false

"
0	Null Shape
1	Point
3	PolyLine
5	Polygon
8	MultiPoint
11	PointZ
13	PolyLineZ
15	PolygonZ
18	MultiPointZ
21	PointM
23	PolyLineM
25	PolygonM
28	MultiPointM
31	MultiPatch
"! !

!ShapeMap methodsFor: 'accessing - records' stamp: 'jmb 4/27/2004 10:17'!
shapeTypeForShapeAtOffset: anInteger
	"anInteger is the byte number of the offset of the record holding Shape info"

	^shpBytes longAt: anInteger + 8 bigEndian: false	"add the 8-byte record header"! !

!ShapeMap methodsFor: 'editing - header' stamp: 'jmb 1/13/2006 16:55'!
shapeType: anInteger
	"position 32, Integer between 0 and 31, Little Endian"

	^shpBytes longAt: 33 put: anInteger bigEndian: false

"
0	Null Shape
1	Point
3	PolyLine
5	Polygon
8	MultiPoint
11	PointZ
13	PolyLineZ
15	PolygonZ
18	MultiPointZ
21	PointM
23	PolyLineM
25	PolygonM
28	MultiPointM
31	MultiPatch
"! !

!ShapeMap methodsFor: 'ByteArray methods' stamp: 'jmb 2/23/2005 11:40'!
shpDoubleAt: index bigEndian: bool 
	"when ByteArray doubleAt:bigEndian: is defined, replace this method by 'shpBytes doubleAt:bigEndian:' "
	"Return a 64 bit float starting from the given byte index"
	| w1 w2 dbl |
	w1 := shpBytes unsignedLongAt: index bigEndian: bool.
	w2 := shpBytes unsignedLongAt: index + 4 bigEndian: bool.
	dbl := Float new: 2.
	bool
		ifTrue: [dbl basicAt: 1 put: w1.
			dbl basicAt: 2 put: w2]
		ifFalse: [dbl basicAt: 1 put: w2.
			dbl basicAt: 2 put: w1].
	^ dbl! !

!ShapeMap methodsFor: 'ByteArray methods' stamp: 'jmb 6/17/2008 08:58'!
shpDoubleAt: index put: value bigEndian: bool 
	"when ByteArray doubleAt:put:bigEndian: is defined, replace this method by 'shpBytes doubleAt:put:bigEndian:' "
	"Store a 64 bit float starting from the given byte index"
	| w1 w2 |
	bool
		ifTrue: [w1 := value basicAt: 1.
			w2 := value basicAt: 2]
		ifFalse: [w1 := value basicAt: 2.
			w2 := value basicAt: 1]. 
	shpBytes unsignedLongAt: index put: w1 bigEndian: bool.
	shpBytes unsignedLongAt: index + 4 put: w2 bigEndian: bool.
	^ value
! !

!ShapeMap methodsFor: 'private' stamp: 'jmb 4/27/2004 10:15'!
shxBytes: aShpBytes
	"store the contents of the index file in shxBytes"

	shxBytes := aShpBytes! !

!ShapeMap methodsFor: 'writing' stamp: 'jmb 1/13/2006 16:46'!
streamedHeaderBytes
	"create the header bytes by streaming" 
	"shpBytes copyFrom: 1 to: 100"
	"(ShapeMap fromFile: 'd:\etarcview\giovanna\navelli_cocullo.shp') streamedHeaderBytes "
"
Header (100 Bytes, structure identical for shp|Bytes and shxBytes):
Position 	Field 			Value 		Type 	Order
Byte 0 		File Code 		9994 		Integer 	Big
Byte 4 		Unused 		0 			Integer 	Big
Byte 8 		Unused 		0 			Integer 	Big
Byte 12 	Unused 		0 			Integer 	Big
Byte 16 	Unused 		0 			Integer 	Big
Byte 20 	Unused 		0 			Integer 	Big
Byte 24 	File Length 		File Length 	Integer 	Big
Byte 28 	Version 		1000 		Integer 	Little
Byte 32 	Shape Type 	Shape Type Integer 	Little
Byte 36 	Bounding Box 	Xmin 		Double 	Little
Byte 44 	Bounding Box 	Ymin 		Double 	Little
Byte 52 	Bounding Box 	Xmax 		Double 	Little
Byte 60 	Bounding Box 	Ymax 		Double 	Little
Byte 68* 	Bounding Box 	Zmin 		Double 	Little
Byte 76* 	Bounding Box 	Zmax 		Double 	Little
Byte 84* 	Bounding Box 	Mmin 		Double 	Little
Byte 92* 	Bounding Box 	Mmax 		Double 	Little
* Unused, with value 0.0, if not Measured or Z type "

	| stream source |
	source := self.	"to test, obtain data from the receiver"
	stream := WriteStream on: (ByteArray new: 100).	"100 bytes for the header"
	stream nextNumber: 4 put: 9994.	"magic number"
	5 timesRepeat: [stream uint32: 0].
	stream nextNumber: 4 put: source fileLength.	"file length"
	stream nextLittleEndianNumber: 4 put: source version.	"version = 1000" 
	stream nextLittleEndianNumber: 4 put: source shapeType.
	(Array with: source xMin with: source yMin with: source xMax with: source yMax) 
		do: [:double | self on: stream putNextDouble: double bigEndian: false].
	stream next: 32 putAll: (ByteArray new: 32).
	^stream contents! !

!ShapeMap methodsFor: 'consistency' stamp: 'jmb 1/12/2006 16:55'!
testByteSizes
	"test the size in Bytes"
	
	| totBytes recsBytes |
	totBytes := self fileLength * 2.
	recsBytes := 0.
	1 to: self numberOfShapes do: [:i | 
		recsBytes := recsBytes + (self recordBytesForShapeIndex: i ) size].
	^(100 + recsBytes) = totBytes ifFalse: [self halt] ifTrue: [true]
	! !

!ShapeMap methodsFor: 'accessing - records' stamp: 'jmb 1/12/2006 17:06'!
totalRecordSizeForRecordAtOffset: anInteger 
	"answer Record Header + Record Contents Size (in 16-bit words) for record starting at offset anInteger"

	^(self recordSizeForRecordAtOffset: anInteger) + 4! !

!ShapeMap methodsFor: 'accessing - header' stamp: 'jmb 4/27/2004 12:56'!
version
	"position 28, always 1000, Little Endian"

	^shpBytes longAt: 29 bigEndian: false! !

!ShapeMap methodsFor: 'editing - header' stamp: 'jmb 1/13/2006 16:54'!
version: anInteger
	"position 28, always 1000, Little Endian"

	^shpBytes longAt: 29 put: 1000 bigEndian: false! !

!ShapeMap methodsFor: 'writing' stamp: 'jmb 7/3/2009 13:53'!
writeMiniMinimalDBF: aString 
	"produce something that is accepted by ArcView"
	"Include just an ID. I think it is also OK to have zero fields...."

	| fields writeBlock xbase |
	fields := OrderedCollection new.
	fields addLast: #('ID' $N 8 0 nil).
	writeBlock := 
			[xbase := XBaseFile on: aString fields: fields.
			1 to: self numberOfShapes
				do: 
					[:i | 
					xbase append.
					xbase atField: 1 put: i]].
	writeBlock ensure: [xbase close]! !

!ShapeMap methodsFor: 'accessing - header' stamp: 'jmb 12/3/2004 12:46'!
xMax
	"byte 52, Double, Little Endian"

	"^shpBytes doubleAt: 53 bigEndian: false "
	
	^self shpDoubleAt: 53 bigEndian: false! !

!ShapeMap methodsFor: 'editing - header' stamp: 'jmb 1/13/2006 16:57'!
xMax: aDouble
	"byte 52, Double, Little Endian"

	"^shpBytes doubleAt: 53 bigEndian: false "
	
	^self shpDoubleAt: 53 put: aDouble bigEndian: false! !

!ShapeMap methodsFor: 'accessing - header' stamp: 'jmb 12/3/2004 12:47'!
xMin
	"byte 36, Double, Little Endian"

	"^shpBytes doubleAt: 37 bigEndian: false "
	
	^self shpDoubleAt: 37 bigEndian: false		! !

!ShapeMap methodsFor: 'editing - header' stamp: 'jmb 1/13/2006 16:57'!
xMin: aDouble
	"byte 36, Double, Little Endian"

	"^shpBytes doubleAt: 37 bigEndian: false "
	
	^self shpDoubleAt: 37 put: aDouble bigEndian: false		! !

!ShapeMap methodsFor: 'accessing - header' stamp: 'jmb 12/3/2004 12:47'!
yMax
	"byte 60, Double, Little Endian"

	"^shpBytes doubleAt: 61 bigEndian: false "
	
	^self shpDoubleAt: 61 bigEndian: false! !

!ShapeMap methodsFor: 'editing - header' stamp: 'jmb 1/13/2006 16:58'!
yMax: aDouble
	"byte 60, Double, Little Endian"

	"^shpBytes doubleAt: 61 bigEndian: false "
	
	^self shpDoubleAt: 61 put: aDouble bigEndian: false! !

!ShapeMap methodsFor: 'accessing - header' stamp: 'jmb 12/3/2004 12:45'!
yMin
	"byte 44, Double, Little Endian"

	"^shpBytes doubleAt: 45 bigEndian: false "
	
	^self shpDoubleAt: 45 bigEndian: false
	! !

!ShapeMap methodsFor: 'editing - header' stamp: 'jmb 1/13/2006 16:58'!
yMin: aDouble
	"byte 44, Double, Little Endian"

	"^shpBytes doubleAt: 45 bigEndian: false "
	
	^self shpDoubleAt: 45 put: aDouble bigEndian: false
	! !

!ShapeMap methodsFor: 'accessing - header' stamp: 'jmb 12/3/2004 12:48'!
zMax
	"byte 76, Double, Little Endian"
	"may be undefined!!"

	"^shpBytes doubleAt: 77 bigEndian: false "
	
	^self shpDoubleAt: 77 bigEndian: false		! !

!ShapeMap methodsFor: 'accessing - header' stamp: 'jmb 12/3/2004 12:46'!
zMin
	"byte 68, Double, Little Endian"
	"may be undefined!!"

	"^shpBytes doubleAt: 69 bigEndian: false "
	
	^self shpDoubleAt: 69 bigEndian: false! !
